REM Released into the public domain April 1, 1995


' TRACKER.BI header file for TRACKER.BAS, and TRACKER2.BAS
' Copyright Cory Wright 1989-1993

' More functions for use with TheDraw
DECLARE FUNCTION TRSCREEN&
DECLARE FUNCTION TRSCREENWIDTH%
DECLARE FUNCTION TRSCREENDEPTH%
DECLARE FUNCTION TRSCREENLENGTH%
'Main functions for Tracker
DECLARE SUB OpeningScreen ()
DECLARE FUNCTION GetMESfile$ (msnum)
DECLARE FUNCTION GetSOMnum! (msnum)
DECLARE SUB DrawScreen ()
DECLARE SUB QuietUpdate ()
DECLARE SUB ScrPause ()
DECLARE SUB Send (ln$)
DECLARE SUB Variablecode (ln$)
DECLARE SUB UserTime (logontime$)
DECLARE SUB NumberOfUsers ()
DECLARE SUB WeeklyStat ()
DECLARE SUB DropAtBaud (dropbaud$)
DECLARE SUB LoadMessageBases ()
DECLARE SUB MStrip (desc$)
DECLARE SUB MScan ()
DECLARE SUB Scan ()
DECLARE SUB Logoff ()
DECLARE SUB TextConfig ()
DECLARE SUB ColorConfig ()
DECLARE SUB Init ()
DECLARE SUB ParseUser ()
DECLARE SUB Config ()
DECLARE SUB Validate (ln$, code!)
DECLARE SUB Box (TRow%, BRow%, LCol%, RCol%, f%, B%)
DECLARE SUB FixTime (timeconv$, newtime$)
DECLARE SUB Acceptuser (acceptfile$, Baudrate$, Username$, deny%)
DECLARE SUB DropDTR (GTPath$, Port%)
DECLARE SUB EnterMSG (GTPath$, subj$, day%, msgfile$)
DECLARE SUB REG2 (BBSNAME$, Regvalue!)
DECLARE SUB REG (BBSNAME$, Regvalue!)
DECLARE SUB DivLine (C%)
DECLARE SUB stripit (ln$)
DECLARE SUB Ybulltotal (bull$)
DECLARE SUB Personal (greet$, firstname$)
DECLARE SUB CTR (st$)
DECLARE FUNCTION QFATTR% (Attr AS INTEGER)
DECLARE FUNCTION QFINDFIRST% (BYVAL recptr AS INTEGER, filename AS STRING, BYVAL Attr AS INTEGER)
DECLARE FUNCTION QCMDLINE% (Parms AS STRING)
DECLARE FUNCTION QCHKDIR% (DirName AS STRING)
DECLARE FUNCTION QWORDS% (StringName AS STRING)
DECLARE FUNCTION QWORD% (StringName AS STRING, BYVAL Index AS INTEGER, Start AS INTEGER, StrLen AS INTEGER)
DECLARE FUNCTION QINPUT% (verstr AS STRING, buffer AS STRING, BYVAL row AS INTEGER, BYVAL col AS INTEGER, BYVAL Attr AS INTEGER, BYVAL page AS INTEGER, BYVAL keys AS INTEGER)
DECLARE FUNCTION QATTR% (BYVAL fore AS INTEGER, BYVAL back AS INTEGER)

TYPE MSGCTL              'MESSAGE.CTL
 deleted AS STRING * 1
 msgnumber AS INTEGER
 sender AS STRING * 31
 whoto AS STRING * 31
 subj AS STRING * 31
 msgdate AS STRING * 9
 destnet AS INTEGER
 msgtime AS STRING * 6
 weekday AS STRING * 1
 filler AS STRING * 2
 destnode AS INTEGER
 priv AS STRING * 1
 recv AS STRING * 1
 junk AS STRING * 8
END TYPE
'
TYPE userctl              'USER.CTL
 deleted AS STRING * 1
 whole AS STRING * 31
 firstdate AS STRING * 9
 firsttime AS STRING * 6
 lastdate AS STRING * 9
 lasttime AS STRING * 6
 credit AS INTEGER
 charges AS INTEGER
 timeson AS INTEGER
 banned AS STRING * 1
 expert AS STRING * 1
 more AS STRING * 1
 location AS STRING * 31
 phone AS STRING * 11
 pw AS STRING * 21
 level AS STRING * 1
 numcalls AS INTEGER
 accumtime AS INTEGER
 protocol AS STRING * 1
 pgln AS INTEGER
 uploadk AS INTEGER
 uploadfiles AS INTEGER
 dnloadk AS INTEGER
 dnloadfiles AS INTEGER
 callernum AS LONG
 hash AS INTEGER
 filler AS STRING * 20
END TYPE

TYPE TrackerCNF         'TRACKER.CNF
  header AS STRING * 7
  bbs AS STRING * 72       ' as of v1.92, bbs from 74 to 72
  serial AS INTEGER        ' new as of v2.01, serial # in registration.
  crc AS STRING * 9
  mailwait AS STRING * 74
  nomail AS STRING * 74
  ratiof AS INTEGER
  ratiok AS INTEGER
  border AS INTEGER     'color
  text AS INTEGER       'color
  bright AS INTEGER     'color
  info AS INTEGER       'color
  udirpath AS STRING * 40
  ratioline AS STRING * 74
  pendingline AS STRING * 74
  accessline AS STRING * 74
  callsline AS STRING * 74
  lastonline AS STRING * 74
  sysannounce AS STRING * 74
  connectline AS STRING * 74
  todaybullb AS STRING * 40
  todaybullc AS STRING * 40
  yestbullb AS STRING * 40
  yestbullc AS STRING * 40
  altmdir AS STRING * 40
  mailscan AS INTEGER
  accept300 AS INTEGER
  accept1200 AS INTEGER
  accept2400 AS INTEGER
  accept4800 AS INTEGER
  exemptlevels AS STRING * 22
  gtversion AS INTEGER
  fshare AS INTEGER
  ratiocheck AS INTEGER
  misc AS STRING * 184
  other AS INTEGER      'future color
END TYPE

TYPE trakscandb         'TSCAN.DB
  user AS INTEGER
  area AS INTEGER
  mailpresent AS STRING * 1   'TP boolean
END TYPE

TYPE trakscandir        'TSCAN.DIR
  desc AS STRING * 75
END TYPE

TYPE trackertime        'TRAKTIME.DAT
 ucall AS INTEGER
 scall AS INTEGER
 utime AS INTEGER
 stime AS INTEGER
 day AS INTEGER
END TYPE

TYPE FileType
     Fname AS STRING * 12
     Fdate AS STRING * 8
     Ftime AS STRING * 5
     Fsize AS LONG
     Fattr AS INTEGER
     Fmonth AS INTEGER
     Fday AS INTEGER
     Fyear AS INTEGER
     Fhour AS INTEGER
     Fminute AS INTEGER
END TYPE


COMMON SHARED domail, mailscan, logontime$, connectline$, laston$, total$, ctoday$, callsline$, sysannounce$, lastonline$, pendingline$, ratioline$, accessline$, dlk, dlf, ulk, ulf, desc$(), base$(), hue$(), Param$(), A$, B$, timeconv$, NumberUsers _
, pending$, ver$, trakndx$, trakctl$, header$, totalbases, ptmdir$, border, text, bright, info, trakcnf$, false, true, null, override, CRLF$, day%, dlen%, dloc%, day$, GTPath$, TPath$, trakinf$, gtmdir$, userctl$, gtuser$, whodis$, trakdir$, udir$,  _
trakmail$, tmail$, traksc$, trakscold$, acceptfile$, tbullb$, tbullc$, ybullb$, ybullc$, trakt$, mth$, daynum$, current$, Port%, whole$, orgwhole$, currentcity$, Baud$, ansi$, showbaud$, level$, first$, event, timeleft$, bbs$, usercrc$, nomail$,  _
mailwait$, ratiof, ratiok, city$, phone$, last$, gtver, ncalls, three, twelve, twentyfour, fortyeight, exemptlvl$, newmsg, bground, dce$, fileshare, ratiochk, versiondate$, verdate$

'$DYNAMIC
DIM SHARED user AS userctl
DIM SHARED msg AS MSGCTL
DIM SHARED cnf AS TrackerCNF
DIM SHARED db AS trakscandb
DIM SHARED dir AS trakscandir
DIM SHARED Qfile AS FileType
DIM SHARED traktime AS trackertime

