REM Released into the public domain April 1, 1995

DECLARE SUB UserTime (logontime$)
DECLARE SUB NumberOfUsers ()
DECLARE SUB WeeklyStat ()
DECLARE SUB DropAtBaud (dropbaud$)
DECLARE SUB LoadMessageBases ()
DECLARE SUB MStrip (desc$)
DECLARE SUB MScan ()
DECLARE SUB Scan ()
DECLARE SUB Logoff ()
DECLARE SUB GeneralConfig ()
DECLARE SUB ColorConfig ()
DECLARE SUB Init ()
DECLARE SUB ParseUser ()
DECLARE SUB Config ()
DECLARE SUB Validate (ln$, code!)
DECLARE SUB Box (TRow%, BRow%, LCol%, RCol%, f%, B%)
DECLARE SUB FixTime (timeconv$, newtime$)
DECLARE SUB Acceptuser (acceptfile$, Baudrate$, Username$, deny%)
DECLARE SUB DropDTR (GTPath$, Port%)
DECLARE SUB EnterMSG (GTPath$, subj$, day%, msgfile$)
DECLARE SUB REG2 (BBSNAME$, Regvalue!)
DECLARE SUB REG (BBSNAME$, Regvalue!)
DECLARE SUB DivLine (C%)
DECLARE SUB stripit (ln$)
DECLARE SUB Ybulltotal (bull$)
DECLARE SUB Personal (greet$, firstname$)
DECLARE SUB CTR (st$)
DECLARE FUNCTION QFATTR% (Attr AS INTEGER)
DECLARE FUNCTION QFINDFIRST% (BYVAL recptr AS INTEGER, filename AS STRING, BYVAL Attr AS INTEGER)
DECLARE FUNCTION QCMDLINE% (Parms AS STRING)
DECLARE FUNCTION QCHKDIR% (DirName AS STRING)
DECLARE FUNCTION QWORDS% (StringName AS STRING)
DECLARE FUNCTION QWORD% (StringName AS STRING, BYVAL Index AS INTEGER, Start AS INTEGER, StrLen AS INTEGER)
DECLARE FUNCTION QINPUT% (verstr AS STRING, buffer AS STRING, BYVAL row AS INTEGER, BYVAL col AS INTEGER, BYVAL Attr AS INTEGER, BYVAL page AS INTEGER, BYVAL keys AS INTEGER)
DECLARE FUNCTION QATTR% (BYVAL fore AS INTEGER, BYVAL back AS INTEGER)
COMMON SHARED A$, B$, timeconv$, NumberUsers, pending$, ver$, trakndx$, trakctl$, header$, totalbases, ptmdir$, border, text, bright, info, trakcnf$, false, true, null, override, CRLF$, day%, dlen%, dloc%, day$, GTPath$, gtrack$, gtmdir$, userctl$,  _
gtuser$, gtcnf$, whodis$, trakdir$, udir$, trakmail$, tmail$, traksc$, trakscold$, acceptfile$, tbullb$, tbullc$, ybullb$, ybullc$, trakt$, mth$, daynum$, current$, Port%, whole$, orgwhole$, Baud$, ansi$, showbaud$, level$, first$, event, timeleft$ _
, bbs$, usercrc$, nomail$, mailwait$, ratiof, ratiok

'$DYNAMIC
'$INCLUDE: 'QBSERIAL.DEC'
'$INCLUDE: 'TRACKER.BI'
CLS
LOCATE 24, 1
PRINT "TRC Tracker!"
DIM SHARED Username$(1 TO 2000)   ' user names
DIM SHARED base$(1 TO 250)    ' message path 
DIM SHARED desc$(1 TO 250)    ' area description
DIM SHARED mlevel$(1 TO 250)  ' levels for each area
DIM SHARED Areainfo(1 TO 250) ' area num for logoff
DIM SHARED msgrec(1 TO 250)   ' msg rec num for logoff
DIM SHARED trakrec(1 TO 250)  ' tndx rec num for logoff
DIM SHARED mlocal(1 TO 250)   ' local msg base flag
DIM SHARED nummsgs(1 TO 250)  ' number of msgs for statistical report
DIM SHARED signs$(1 TO 250)   ' pos or neg on 'nummsgs'
DIM SHARED HighPtr(1 TO 250)  ' high pointer
DIM SHARED UserTally(1 TO 250)' # users joined in msg base
DIM SHARED ActiveMsg(1 TO 250)' # active msgs in bases
DIM SHARED hue$(1 TO 15)      ' array of color
DIM SHARED areawaiting(1 TO 250)
DIM SHARED msgwaiting(1 TO 250)
DIM SHARED fromwaiting$(1 TO 250)
DIM SHARED subjwaiting$(1 TO 250)
DIM SHARED Param$(0 TO 40)
ON ERROR GOTO 20000
' Tracker! by Cory Wright 8/9/1989
ver$ = "v1.373"
false = 0
true = NOT false
debug = true
null = false
override = false
CRLF$ = CHR$(13) + CHR$(10)
'
TYPE MSGCTL              'MESSAGE.CTL
 deleted AS STRING * 1
 msgnumber AS INTEGER
 sender AS STRING * 31
 whoto AS STRING * 31
 subj AS STRING * 31
 msgdate AS STRING * 9
 destnet AS INTEGER
 msgtime AS STRING * 6
 weekday AS STRING * 1
 filler AS STRING * 2
 destnode AS INTEGER
 priv AS STRING * 1
 recv AS STRING * 1
 junk AS STRING * 8
END TYPE
'
TYPE userctl              'USER.CTL
 deleted AS STRING * 1
 whole AS STRING * 31
 firstdate AS STRING * 9
 firsttime AS STRING * 6
 lastdate AS STRING * 9
 lasttime AS STRING * 6
 credit AS INTEGER
 charges AS INTEGER
 timeson AS INTEGER
 banned AS STRING * 1
 expert AS STRING * 1
 more AS STRING * 1
 location AS STRING * 31
 phone AS STRING * 11
 pw AS STRING * 21
 level AS STRING * 1
 numcalls AS INTEGER
 accumtime AS INTEGER
 protocol AS STRING * 1
 pgln AS INTEGER
 uploadk AS INTEGER
 uploadfiles AS INTEGER
 dnloadk AS INTEGER
 dnloadfiles AS INTEGER
 callernum AS LONG
 hash AS INTEGER
 filler AS STRING * 20
END TYPE

TYPE TrackerCNF         'TRACKER.CNF
  header AS STRING * 7
  bbs AS STRING * 74
  crc AS STRING * 9
  mailwait AS STRING * 74
  nomail AS STRING * 74
  ratiof AS INTEGER
  ratiok AS INTEGER
  border AS INTEGER     'color
  text AS INTEGER       'color
  bright AS INTEGER     'color
  info AS INTEGER       'color
  udirpath AS STRING * 40
END TYPE

TYPE PowertoolsMDIR     'PTMDIR.BBS
  mlocal AS STRING * 1
  mlevel AS STRING * 1
  mbase AS STRING * 40
  mdesc AS STRING * 74
END TYPE

TYPE trakmailuserfile   'temp file during scan
  userlevel AS STRING * 1
  usernumber AS LONG
END TYPE

TYPE trackerindex       'TRACKER.NDX
  usernumber AS LONG
  trecord AS LONG
  deleted AS STRING * 1
END TYPE

TYPE trackerctl         'TRACKER.CTL
  area AS INTEGER
  msg AS LONG
  msgrecord AS LONG
  from AS STRING * 31
  subj AS STRING * 31
END TYPE

TYPE trakuserdata       'PENDING.CTL
 area AS INTEGER
 msgrec AS LONG
 trakrec AS LONG
END TYPE

TYPE trackertime        'TRAKTIME.DAT
 ucall AS INTEGER
 scall AS INTEGER
 utime AS INTEGER
 stime AS INTEGER
 day AS INTEGER
END TYPE

TYPE tmailctl           'TMAIL.CTL w/high pointers on logon
 highmsg AS INTEGER
END TYPE

TYPE trakscandat
 active AS INTEGER
 usercount AS INTEGER
END TYPE

DIM SHARED user AS userctl
DIM SHARED msg AS MSGCTL
DIM SHARED cnf AS TrackerCNF
DIM SHARED mdir AS PowertoolsMDIR
DIM SHARED userfile AS trakmailuserfile
DIM SHARED tndx AS trackerindex
DIM SHARED tctl AS trackerctl
DIM SHARED pendingctl AS trakuserdata
DIM SHARED traktime AS trackertime
DIM SHARED tmailctl AS tmailctl
DIM SHARED trakscan AS trakscandat

' get weekday
850 CALL weekday(day%)
855 dlen% = VAL(MID$("3346535", day%, 1))
860 dloc% = ASC(MID$("ADGKQVY", day%)) - 64
865 day$ = MID$("SunMonTuesWednesThursFriSaturSun", dloc%, dlen%) + "day,"

' initialize global variables
545 GTPath$ = ENVIRON$("GTPATH")
	GTPath$ = LCASE$(GTPath$)
550 IF GTPath$ = "" THEN
555 COLOR 12
560  BEEP
565  BEEP
570 CTR "Your GTPATH must be SET to your GT Directory."
575 END
580 END IF
'
585 IF RIGHT$(GTPath$, 1) <> "\" THEN GTPath$ = GTPath$ + "\"

 mo$ = SPACE$(9)
 mnum% = VAL(LEFT$(DATE$, 2))
 CALL month(mo$, ml%, mnum%)
 mth$ = LEFT$(mo$, ml%)

 daynum$ = MID$(DATE$, 4, 2)
 IF LEFT$(daynum$, 1) = "0" THEN daynum$ = RIGHT$(daynum$, 1)
 daynum$ = daynum$ + ","

 FixTime TIME$, timeconv$
 current$ = day$ + SPACE$(1) + mth$ + SPACE$(1) + daynum$ + SPACE$(1) + RIGHT$(DATE$, 4)

 gtrack$ = GTPath$ + "trak.bbs"
 gtmdir$ = GTPath$ + "gtmdir.bbs"
 ptmdir$ = GTPath$ + "ptmdir.bbs"
 userctl$ = GTPath$ + "user.ctl"
 gtuser$ = GTPath$ + "gtuser.bbs"
 gtcnf$ = GTPath$ + "gt.cnf"
 trakcnf$ = GTPath$ + "tracker.cnf"
 whodis$ = GTPath$ + "whodis.bbs"
 trakctl$ = GTPath$ + "tracker.ctl"
 trakndx$ = GTPath$ + "tracker.ndx"
 pending$ = GTPath$ + "pending.ctl"
 trakmail$ = GTPath$ + "trakmail.bbs"
 tmail$ = GTPath$ + "tmail.ctl"
 traksc$ = GTPath$ + "trakscan.dat"
 trakscold$ = GTPath$ + "trakscan.old"
 acceptfile$ = GTPath$ + "accept.trc"
 tbullb$ = GTPath$ + "whotoday.bbs"
 tbullc$ = GTPath$ + "whotoday.cbs"
 ybullb$ = GTPath$ + "whoyest.bbs"
 ybullc$ = GTPath$ + "whoyest.cbs"
 trakt$ = GTPath$ + "traktime.dat"

'init traktime.dat and tracker.cnf if doesn't exist
CALL exist(trakt$ + CHR$(0), th%)
  IF NOT th% THEN         'Init TRAKTIME.DAT
	OPEN trakt$ FOR RANDOM AS 2 LEN = LEN(traktime)
	FOR J = 1 TO 7
	traktime.ucall = 0
	traktime.scall = 0
	traktime.utime = 0
	traktime.stime = 0
	traktime.day = 0
	PUT 2, J, traktime
	NEXT J
	CLOSE 2
  END IF
CALL exist(trakcnf$ + CHR$(0), th%)
  IF NOT th% THEN           'init TRACKER.CNF
	OPEN trakcnf$ FOR RANDOM AS 2 LEN = LEN(cnf)
	cnf.header = ver$
	cnf.bbs = "The Rising Connection"
	cnf.crc = "0000-0000"
	cnf.mailwait = "@FIRST@, you have mail waiting in the following areas:"
	cnf.nomail = "No mail is waiting for you in the message areas, @FIRST@"
	cnf.ratiof = 0
	cnf.ratiok = 0
	cnf.border = 9
	cnf.text = 7
	cnf.bright = 11
	cnf.info = 15
	cnf.udirpath = ""
	PUT 2, 1, cnf
	CLOSE 2
  END IF

'get configuration information
  OPEN trakcnf$ FOR RANDOM AS 2 LEN = LEN(cnf)
  GET 2, 1, cnf
   header$ = LTRIM$(RTRIM$(cnf.header))
   bbs$ = LTRIM$(RTRIM$(cnf.bbs))
   usercrc$ = LTRIM$(RTRIM$(cnf.crc))
   mailwait$ = LTRIM$(RTRIM$(cnf.mailwait))
   nomail$ = LTRIM$(RTRIM$(cnf.nomail))
   ratiof = cnf.ratiof
   ratiok = cnf.ratiok
   border = cnf.border
   text = cnf.text
   bright = cnf.bright
   info = cnf.info
   udir$ = LTRIM$(RTRIM$(cnf.udirpath))
  CLOSE 2
IF udir$ = "" THEN
  BEEP: BEEP
  PRINT "Running CONFIG to set up the mandatory path to temporary files..."
  SLEEP (2)
  GeneralConfig
END IF

'rescan message bases if archive bit set
Fptr = VARPTR(Qfile)
chkfile$ = gtmdir$ + CHR$(0)
IF QFINDFIRST(Fptr, chkfile$, 0) = 0 THEN
  IF Qfile.Fattr = &H20 THEN
  scanmdir$ = "Parsing " + UCASE$(gtmdir$) + " into POWER! Tools Quick Index file..."
  PRINT scanmdir$
	 MScan
  END IF
 ELSE      'file not there
  PRINT scanmdir$
  MScan
END IF
'clear archive bit on GTMDIR.BBS
CALL setfattr(chkfile$, &H0)

'draw initial screen
CLS
CALL Box(22, 24, 2, 78, 8, 0)
LOCATE 23, 5
COLOR info
key$ = "Tracker! by Cory Wright - Only from The Rising Connection  615-531-8789"
PRINT key$
Validate key$, 34786

COLOR 8, 0
CALL Box(1, 5, 2, 78, 8, 0)
LOCATE 1, 59
PRINT "["; : COLOR bright: PRINT "User Information"; : COLOR 8: PRINT "]"

' call other procedures
	IF INSTR(COMMAND$, "/CONFIG") THEN Config
	IF INSTR(COMMAND$, "/INIT") THEN Init
	IF INSTR(COMMAND$, "/SCAN") THEN Scan
	IF INSTR(COMMAND$, "/END") THEN
	NumberOfUsers
	REDIM Username$(1 TO NumberUsers)
	Logoff
	END IF
655 complace = INSTR(COMMAND$, "/PORT:")
	IF complace <> 0 THEN
	Port% = VAL(MID$(COMMAND$, complace + 6, 1))
	ELSE
	Port% = 1
659    END IF
660 IF INSTR(COMMAND$, "/PAUSE") THEN pause = true
	dteplace = INSTR(COMMAND$, "/NOBAUD")  ' later on, if 0, then change line 1
	IF INSTR(COMMAND$, "/NULL") THEN
	   null = true
	   ansi$ = "ANSI"
	END IF
	IF INSTR(COMMAND$, "/OVERRIDE") THEN override = true
	IF INSTR(COMMAND$, "/OZ") THEN whodis = true
	IF INSTR(COMMAND$, "/XON") THEN
	Handshake% = 1
	ELSEIF INSTR(COMMAND$, "/BOTH") THEN
	Handshake% = 3
	ELSEIF INSTR(COMMAND$, "/CTS") THEN
	Handshake% = 2
	ELSE
	Handshake% = 0
661    END IF

' main code
665 OPEN gtrack$ FOR INPUT AS 1
670 LINE INPUT #1, Total$
675 LINE INPUT #1, laston$
680 LINE INPUT #1, city$
685 LINE INPUT #1, today$
690 LINE INPUT #1, ctoday$
695 CLOSE
'

ParseUser
IF null = true THEN Baud$ = "LOCAL"
  IF Baud$ <> "LOCAL" THEN
	   ON UEVENT GOSUB 30000   'set up tracking after parsing
	   UEVENT ON
701     END IF

1630 OPEN userctl$ FOR RANDOM AS 11 LEN = LEN(user)
1635 recs = LOF(11) / LEN(user)
1640 FOR A = 2 TO recs
1645 GET 11, A, user
1650 wholelen = LEN(whole$)
1655 IF LEFT$(user.whole, wholelen) = whole$ THEN 1685
1660 NEXT A
1665  BEEP
1670  COLOR 12
1675  CTR "I could not find " + laston$ + "'s record in the user file!"
1680  END
1685 orgwhole$ = whole$
1695 COLOR 7
1700 LOCATE 3, 16
1705 PRINT "User " + LTRIM$(STR$(A - 1)) + "    Level " + user.level

IF ansi$ = "ANSI" THEN
 hue$(1) = CHR$(27) + "[2;34m"
 hue$(2) = CHR$(27) + "[2;32m"
 hue$(3) = CHR$(27) + "[2;36m"
 hue$(4) = CHR$(27) + "[2;31m"
 hue$(5) = CHR$(27) + "[2;35m"
 hue$(6) = CHR$(27) + "[2;33m"
 hue$(7) = CHR$(27) + "[0m"
 hue$(8) = CHR$(27) + "[1;30m"
 hue$(9) = CHR$(27) + "[1;34m"
 hue$(10) = CHR$(27) + "[1;32m"
 hue$(11) = CHR$(27) + "[1;36m"
 hue$(12) = CHR$(27) + "[1;31m"
 hue$(13) = CHR$(27) + "[1;35m"
 hue$(14) = CHR$(27) + "[1;33m"
 hue$(15) = CHR$(27) + "[1;37m"
ELSE
 FOR z = 1 TO 15
   hue$(z) = ""
 NEXT z
END IF

	IF Baud$ <> "LOCAL" THEN
	OpenComm Port%, 0, 0, 0, Handshake%
	ELSE
	OpenComm 0, 0, 0, 0, 0
	hue$(text) = ""          'be sure if local that text color has no ansi
	END IF

'fix local logon string
905 showbaud$ = Baud$
IF whodis = true THEN
  CALL exist(whodis$ + CHR$(0), f%)
 IF f% THEN
   nf = FREEFILE
   OPEN whodis$ FOR INPUT AS nf
   LINE INPUT #nf, dcerate$
   CLOSE nf
   showbaud$ = dcerate$
   LOCATE 2, 68
   COLOR 9
   PRINT "-Who Dis?-"
 END IF
END IF

DropAtBaud "300"
DropAtBaud "1200"
DropAtBaud "2400"
DropAtBaud "4800"

IF override = true THEN user.level = "1"
	
710 COLOR 7
715 LOCATE 2, 4
720 PRINT "User Name:  ";
	COLOR info
	PRINT whole$
730 LOCATE 4, 4
735 IF ansi$ = "ANSI" THEN
	COLOR info
	PRINT "ANSI On"
	  ELSE
	COLOR 7
	PRINT "ANSI Off"
739    END IF
COLOR 7
LOCATE 4, 16
IF Baud$ <> "LOCAL" THEN
	PRINT "Output to "; : COLOR info: PRINT "COM" + LTRIM$(STR$(Port%)) + ":"; : COLOR 7: PRINT " @ "; : COLOR info: PRINT Baud$; : COLOR 7: PRINT " baud."
  ELSE
	PRINT "Output to Local Screen Only."
END IF

'find and print connection information

910 IF showbaud$ = "LOCAL" OR showbaud$ = "0" THEN
915     showbaud$ = "Locally"
920   ELSE
925     showbaud$ = "at " + showbaud$ + " baud"
930 END IF
'

1470 COLOR info
1475 LOCATE 7
1030 IF dteplace = 0 THEN
	C$ = "Connected " + showbaud$ + " on " + current$ + " - " + timeconv$
	sp = 38 - (INT(LEN(C$) / 2))
	connect$ = CRLF$ + CRLF$ + SPACE$(sp) + hue$(info) + "Connected " + showbaud$ + " on " + current$ + " - " + timeconv$ + CRLF$
	PRINT SPACE$(sp) + "Connected " + showbaud$ + " at " + timeconv$ + " on " + current$ + "."
	  ELSE
	C$ = "It is presently " + timeconv$ + " on " + current$ + "."
	sp = 38 - (INT(LEN(C$) / 2))
	connect$ = CRLF$ + CRLF$ + SPACE$(sp) + hue$(info) + "It is presently " + timeconv$ + " on " + current$ + "." + CRLF$
	PRINT SPACE$(sp) + "It is presently " + timeconv$ + " on " + current$ + "."
1039 END IF
1040 Transmit connect$

' see if sysop defined personal greeting with a @CODE@
Personal mailwait$, first$
Personal nomail$, first$
' check registration
regv1 = 0
REG bbs$, regv1
regv2 = 0
REG2 bbs$, regv2
crc$ = HEX$(regv1) + "-" + HEX$(regv2)

LOCATE 1, 46
COLOR 8
IF usercrc$ = crc$ THEN Register = true
IF usercrc$ = HEX$(8726) + "-" + HEX$(37923) THEN Beta = true
IF Register = true THEN
   PRINT "["; : COLOR info: PRINT "Registered"; : COLOR 8: PRINT "]"
   regline$ = "- Registered - "
   regist = info
   regcolor$ = hue$(info)
ELSEIF Beta = true THEN
   PRINT "["; : COLOR 9: PRINT "Auth Beta"; : COLOR 8: PRINT "]"
   regline$ = "  Auth Beta  "
   regist = 9
   regcolor$ = hue$(9)
   Register = true
 ELSE
  ' shut down if not beta
  CLS
  BEEP: BEEP: COLOR 7: PRINT
  PRINT "ALERT! BETA Software!  Auto-shutdown due to lack of clearance by author."
  PRINT "Beta testers should obtain a CRC from Cory Wright (615) 531-8789 Data"
  END
  'remove above lines in released code
  PRINT "["; : COLOR 12: PRINT "UnRegistered"; : COLOR 8: PRINT "]"
  regline$ = "(UNREGISTERED) "
  Validate regline$, 16643
  regist = 12
  regcolor$ = hue$(12)
1069 END IF

LoadMessageBases

IF null = true THEN
   user.level = "0"
   GOTO 1140
END IF
1110 OPEN tmail$ FOR RANDOM AS 31 LEN = LEN(tmailctl)
	 LOCATE 4, 47: COLOR 7: PRINT "Indexing Msg Bases";
1115 FOR D = 1 TO totalbases
1120 OPEN base$(D) FOR RANDOM AS 30 LEN = LEN(msg)
1121 tmailctl.highmsg = LOF(30) / LEN(msg)
1125 PUT #31, D, tmailctl
1130 CLOSE 30
1135 NEXT D
LOCATE 4, 47: PRINT "Message Index Done";
'
1140 IF user.level <> "0" THEN Total$ = LTRIM$(STR$(VAL(Total$) + 1))
1145 IF today$ = DATE$ THEN
1150  IF user.level <> "0" THEN
1155     ctoday$ = LTRIM$(STR$(VAL(ctoday$) + 1))
	
	 IF null = true THEN 1200
	 'add USER call to TRAKTIME
	 OPEN trakt$ FOR RANDOM AS 7 LEN = LEN(traktime)
	 GET 7, day%, traktime
	 IF override = false THEN
	   traktime.ucall = traktime.ucall + 1
	  ELSE
	   traktime.scall = traktime.scall + 1
1199     END IF
	   traktime.day = VAL(MID$(DATE$, 4, 2))
	 PUT 7, day%, traktime
1200       CLOSE 7
	  ELSE
1205     COLOR info
1210     LOCATE 3, 47
1215     PRINT "SysOp Override"
1225     ctoday$ = LTRIM$(STR$(VAL(ctoday$)))
	
	 IF null = true THEN 1230
	 'add SYSOP call to TRAKTIME
	 OPEN trakt$ FOR RANDOM AS 7 LEN = LEN(traktime)
	 GET 7, day%, traktime
	 traktime.scall = traktime.scall + 1
	 traktime.day = VAL(MID$(DATE$, 4, 2))
	 PUT 7, day%, traktime
	 CLOSE 7

1230  END IF
1235 ELSE 'set up a new day
1245 COLOR 9
1250 LOCATE 5, 57
1255 PRINT "[Setting up a new day]"
1265 IF user.level = "0" THEN ctoday$ = "0" ELSE ctoday$ = "1"

' its a new day! copy whotoday.* to whoyest.*
1305 CALL copyfile(tbullb$ + CHR$(0), ybullb$ + CHR$(0), errcode%)
1310 CALL copyfile(tbullc$ + CHR$(0), ybullc$ + CHR$(0), errcode%)
Ybulltotal ybullb$
Ybulltotal ybullc$
' recreate today's bulletin
1315 OPEN tbullb$ FOR OUTPUT AS 6
1320 OPEN tbullc$ FOR OUTPUT AS 7
1325 opening$ = "User Activity Detail for " + current$ + " - Tracker! " + ver$
1330 PRINT #6, ""
1335 PRINT #6, SPACE$(39 - (LEN(opening$) / 2)) + opening$
1340 PRINT #6, STRING$(79, 196)
1345 PRINT #6, SPACE$(2) + "Name" + SPACE$(17) + "From" + SPACE$(22) + "Logon @" + SPACE$(4) + "Logoff @" + SPACE$(3) + "Used"
1350 PRINT #6, STRING$(79, 196)
1355 PRINT #6, ""
1360 PRINT #7, CHR$(27) + "[2J"   'clear screen
1365 PRINT #7, hue$(info) + SPACE$(39 - (LEN(opening$) / 2)) + opening$ + CHR$(27) + "[0m"
1370 PRINT #7, hue$(border) + STRING$(79, 196) + CHR$(27) + "[0m"
1375 PRINT #7, hue$(info) + SPACE$(2) + "Name" + SPACE$(17) + "From" + SPACE$(22) + "Logon @" + SPACE$(4) + "Logoff @" + SPACE$(3) + "Used" + CHR$(27) + "[0m"
1380 PRINT #7, hue$(border) + STRING$(79, 196) + CHR$(27) + "[0m"
1385 PRINT #7, ""
	 CLOSE 6, 7
'new day! if Sunday ,and TRAKTIME's there, create a report and clear data
  CALL exist(trakt$ + CHR$(0), L%)
  IF NOT L% THEN 1420
	 IF day% = 1 THEN
	  WeeklyStat
	 END IF
  END IF
'
1420 Transmit SPACE$(1) + hue$(border) + STRING$(74, 196) + CRLF$
1425 callerline$ = hue$(bright) + SPACE$(3) + first$ + hue$(text) + ", you are caller " + hue$(bright) + ctoday$ + hue$(text) + " today and #"
	 callerline$ = callerline$ + hue$(bright) + Total$ + hue$(text) + " to date." + CRLF$
	 Transmit callerline$
1430 Transmit hue$(bright) + SPACE$(3) + laston$ + hue$(text) + " from " + hue$(bright) + city$ + hue$(text) + " was the last person on." + CRLF$
1431 Transmit hue$(border) + SPACE$(34) + STRING$(10, 196) + CRLF$
'
VIEW PRINT 7 TO 20
COLOR border
LOCATE 8, 4
PRINT STRING$(74, 196)
COLOR bright
LOCATE 9, 4
PRINT SPACE$(2); first$;
 COLOR text
 PRINT ", you are caller ";
 COLOR bright
 PRINT ctoday$;
 COLOR text
 PRINT " today and #";
 COLOR bright
 PRINT Total$;
 COLOR text
 PRINT " to date."
 COLOR bright
 LOCATE 10, 4
 PRINT SPACE$(2) + laston$;
 COLOR text
 PRINT " from ";
 COLOR bright
 PRINT city$;
 COLOR text
 PRINT " was the last person on."
 LOCATE 11, 35
 COLOR border
 PRINT STRING$(10, 196)
CLOSE

1800 IF event = 1 THEN
1805    line6$ = hue$(12) + SPACE$(3) + "Due to a pending system event, you have only " + hue$(11) + timeleft$ + hue$(12) + " minutes for this call." + CRLF$
1810   ELSE
1815    line6$ = SPACE$(3) + hue$(text) + "You have an access level of " + hue$(bright) + user.level + hue$(text) + " with " + hue$(bright) + timeleft$ + hue$(text) + " minutes left for this call." + CRLF$
1820 END IF
verdate$ = " of 12/22/1989: (C) 1989 Cory Wright  "
1830 line9$ = SPACE$(1) + hue$(border) + STRING$(74, 196) + CRLF$
	 line10$ = SPACE$(3) + hue$(info) + "Tracker! " + ver$ + verdate$ + regcolor$ + regline$ + hue$(7) + CRLF$ + CRLF$

1840  Transmit line6$
	  Transmit hue$(border) + SPACE$(34) + STRING$(10, 196) + CRLF$


1860 LOCATE 12, 4
1865 PRINT SPACE$(2);
1870 IF event = 1 THEN
1875   COLOR 12
1880    PRINT "Due to a pending system event, you have only ";
1885    COLOR info
1890    PRINT timeleft$;
1895    COLOR 12
1900    PRINT " minutes for this call."
1905  ELSE
1910   COLOR text
1915    PRINT "You have an access level of ";
1920    COLOR bright
1925    PRINT user.level;
1930    COLOR text
1935    PRINT " with ";
1940    COLOR bright
1945    PRINT timeleft$;
1950    COLOR text
1955    PRINT " minutes left for this call."
1960 END IF
LOCATE 13, 35
COLOR border
PRINT STRING$(10, 196)

'inform user of wait
ln$ = hue$(bright) + SPACE$(3) + "Checking for mail addressed to you..."
Transmit ln$
COLOR bright
PRINT SPACE$(5) + "Checking for mail addressed to you...";

CALL exist(pending$ + CHR$(0), pexist%)
IF pexist% THEN KILL pending$
' see if they have mail by reading in ndx & ctl and write to PENDING.CTL
OPEN trakndx$ FOR RANDOM AS 3 LEN = LEN(tndx)
OPEN trakctl$ FOR RANDOM AS 4 LEN = LEN(tctl)
OPEN pending$ FOR RANDOM AS 8 LEN = LEN(pendingctl)
 messageswaiting = 0
 FOR R = 1 TO LOF(3) / LEN(tndx)
	GET 3, R, tndx
	  IF tndx.usernumber = A AND tndx.deleted <> CHR$(1) THEN
	messageswaiting = messageswaiting + 1
	GET 4, tndx.trecord, tctl
	areawaiting(messageswaiting) = tctl.area
	msgwaiting(messageswaiting) = tctl.msg
	fromwaiting$(messageswaiting) = tctl.from
	subjwaiting$(messageswaiting) = tctl.subj
	pendingctl.area = tctl.area
	pendingctl.msgrec = tctl.msgrecord
	pendingctl.trakrec = R               'NDX record
	PUT 8, messageswaiting, pendingctl
	  END IF
 NEXT R
CLOSE 3, 4, 8

IF messageswaiting = 0 THEN
  KILL pending$
  COLOR bright
  LOCATE CSRLIN, 6
  PRINT nomail$
  Transmit STRING$(39, 8)  'erase wait line
  Transmit SPACE$(3) + nomail$ + CRLF$
 ELSE
  COLOR 11
  LOCATE CSRLIN, 6
  PRINT mailwait$
  Transmit STRING$(39, 8)  'erase wait line
  Transmit SPACE$(3) + hue$(11) + mailwait$ + CRLF$
END IF

mailheader$ = SPACE$(1) + hue$(border) + " " + hue$(bright) + "Msg #" + hue$(border) + "  " + hue$(bright) + "From" + SPACE$(26) + hue$(border)
mailheader$ = mailheader$ + " " + hue$(bright) + "Subject" + SPACE$(22) + hue$(border) + ""
msgcounter = 1
DO
  IF msgcounter > messageswaiting THEN EXIT DO
  ln$ = SPACE$(3) + hue$(info) + "[Mail] Area " + LTRIM$(STR$(areawaiting(msgcounter))) + ":  " + LEFT$(desc$(areawaiting(msgcounter)), 56) + CRLF$
  Transmit ln$
  COLOR info
  PRINT SPACE$(5); "[Mail] Area " + LTRIM$(STR$(areawaiting(msgcounter))) + ":  " + LEFT$(desc$(areawaiting(msgcounter)), 56)
  Transmit mailheader$
  COLOR border
  PRINT SPACE$(3); " "; : COLOR bright: PRINT "Msg #"; : COLOR border: PRINT "  "; : COLOR bright: PRINT "From" + SPACE$(26); : COLOR border
  PRINT " "; : COLOR bright: PRINT "Subject" + SPACE$(22); : COLOR border: PRINT ""
  COLOR text
  ln$ = SPACE$(3) + hue$(text) + LTRIM$(STR$(msgwaiting(msgcounter))) + SPACE$(9 - LEN(LTRIM$(STR$(msgwaiting(msgcounter))))) + LTRIM$(fromwaiting$(msgcounter)) + SPACE$(33 - LEN(LTRIM$(fromwaiting$(msgcounter)))) + LTRIM$(subjwaiting$(msgcounter))
  Transmit ln$
  PRINT SPACE$(2) + ln$
	DO
	 msgcounter = msgcounter + 1
	 IF msgcounter > messageswaiting THEN EXIT DO
	 IF areawaiting(msgcounter) <> areawaiting(msgcounter - 1) THEN EXIT DO
	 ln$ = SPACE$(3) + hue$(text) + LTRIM$(STR$(msgwaiting(msgcounter))) + SPACE$(9 - LEN(LTRIM$(STR$(msgwaiting(msgcounter))))) + LTRIM$(fromwaiting$(msgcounter)) + SPACE$(33 - LEN(LTRIM$(fromwaiting$(msgcounter)))) + LTRIM$(subjwaiting$(msgcounter _
))
	 Transmit ln$
	 PRINT SPACE$(2) + ln$
	LOOP
  msgcounter = msgcounter + 1
LOOP


IF user.dnloadfiles = 0 OR user.dnloadk = 0 THEN 2100

' check for access levels to bypass
position = INSTR(COMMAND$, "/EXEMPT:")
IF position = 0 THEN 2090
Cmdline$ = SPACE$(LEN(COMMAND$))
IF QCMDLINE%(Cmdline$) > 0 THEN
2082   tmp$ = MID$(Cmdline$, position, LEN(Cmdline$) - position)
	   cnt = 0
	   DO
	   cnt = cnt + 1
	   IF cnt > LEN(tmp$) THEN EXIT DO
2083   ch$ = MID$(tmp$, cnt + 8, 1)
	   IF ch$ <> " " OR ch$ <> CHR$(0) THEN exempts$ = exempts$ + ch$
	   IF ch$ = CHR$(32) THEN EXIT DO
	   LOOP
2084  IF INSTR(exempts$, user.level) <> 0 THEN
	  saveline = CSRLIN
	  VIEW PRINT 1 TO 25
	  COLOR 15: LOCATE 2, 47: PRINT "Ratio Exempt";
	  VIEW PRINT 7 TO 20
	  LOCATE saveline
	  GOTO 2100 'skip ratio check
 M$ = SPACE$(9)
END IF

2090 IF user.uploadfiles = 0 THEN user.uploadfiles = 1
	 IF user.uploadk = 0 THEN user.uploadk = 1
userratiof = user.dnloadfiles / user.uploadfiles
userratiok = user.dnloadk / user.uploadk
IF userratiok > ratiok THEN bal = 1
IF userratiof > ratiof THEN bal = 1
	  IF bal = 1 AND user.level <> "0" THEN
	Transmit hue$(12) + SPACE$(3) + "Caution: " + LTRIM$(STR$(user.dnloadk)) + "K in " + LTRIM$(STR$(user.dnloadfiles)) + " files downloaded, " + LTRIM$(STR$(user.uploadk)) + "K in " + LTRIM$(STR$(user.uploadfiles)) + " files uploaded! " + CRLF$
	COLOR 12
	PRINT SPACE$(5) + "Caution: " + LTRIM$(STR$(user.dnloadk)) + "K in " + LTRIM$(STR$(user.dnloadfiles)) + " files downloaded, " + LTRIM$(STR$(user.uploadk)) + "K in " + LTRIM$(STR$(user.uploadfiles)) + " files uploaded!"
	  END IF

2100    Transmit line9$
2101    Transmit line10$

2109 IF Baud$ <> "LOCAL" THEN  ' Close the comport!
	CloseComm
	UEVENT OFF
	 END IF
'
2115 COLOR border
LOCATE CSRLIN, 4
PRINT STRING$(74, 196)
2120 LOCATE CSRLIN, 6
2130  COLOR info
2135  PRINT "Tracker! " + ver$;
	  PRINT " of 12/22/1989: (C) 1989 Cory Wright  ";
	  COLOR regist: PRINT regline$;

2155 OPEN gtrack$ FOR OUTPUT AS 1
2160 PRINT #1, Total$
2165 IF user.level <> "0" THEN
2170    PRINT #1, orgwhole$
2175    PRINT #1, user.location
2180  ELSE
2185    PRINT #1, laston$
2190    PRINT #1, city$
2195 END IF
2200 PRINT #1, DATE$
2205 IF today$ = DATE$ THEN
2210    PRINT #1, ctoday$
2215 ELSE
2220    PRINT #1, "0"
2225 END IF
2230 PRINT #1, LTRIM$(STR$(A))   ' record number
2235 PRINT #1, TIME$     ' time for ending
2236 PRINT #1, user.level
2240 CLOSE
IF user.level <> "0" THEN
 IF hasmail = true THEN
   OPEN GTPath$ + "YESMAIL.TRC" FOR OUTPUT AS 12
   CLOSE 12
  ELSE
   OPEN GTPath$ + "NOMAIL.TRC" FOR OUTPUT AS 12
   CLOSE 12
 END IF
END IF

2245 IF pause = true THEN
	  Transmit CRLF$ + hue$(text) + " Press " + hue$(bright) + "RETURN" + hue$(text) + " to continue..."
	  COLOR 7
	  PRINT SPACE$(4) + "Press "; : COLOR 11: PRINT "RETURN"; : COLOR 7: PRINT " to continue..."
	  ClearInputBuffer
	  DO
	   H$ = INKEY$
	   IF H$ <> "" THEN EXIT DO
	  LOOP UNTIL DataWaiting
	 Transmit CRLF$
2285 END IF
   
	 VIEW PRINT 1 TO 25
	 CALL clrkbd
2290 LOCATE 24, 49
'     IF hasmail = true THEN Errorlevel% = 2 ELSE Errorlevel% = 0
'     PRINT "[Exiting with errorlevel " + LTRIM$(STR$(Errorlevel%)) + "]";
	 CLOSE
	 IF Register = false THEN CALL delay(5)
'     QEXIT Errorlevel%
2294 END


20000   'error handling
 COLOR 12
  BEEP
 PRINT "Error " + STR$(ERR) + "  -  Aborting"
 OPEN GTPath$ + "TRACKER.ERR" FOR APPEND AS 50
 PRINT #50, DATE$ + " " + LEFT$(TIME$, 5) + "-Error " + STR$(ERR) + "-line " + STR$(ERL)
 IF ERR = 62 THEN
   PRINT #50, "Input past end of file error.  Please recheck your TRAKMAIL.BBS"
   PRINT #50, "file for extra commas, semicolons, quotes, and blank lines at the end of"
   PRINT #50, "the file.  Contact the author if you can't seem to solve the problem."
 END IF
 PRINT #50, STRING$(60, 196) + " Tracker! " + ver$
 CLOSE
' Errorlevel% = 5
' PRINT "Exiting with errorlevel " + LTRIM$(STR$(Errorlevel%)) + "."
' QEXIT Errorlevel%
 END

30000 'uevent triggered - carrier loss
COLOR 12
PRINT : PRINT
CTR "Carrier Loss Detected -- Exiting"
PRINT : PRINT
GOTO 30010
RETURN

30010 IF UCASE$(Baud$) <> "LOCAL" THEN CloseComm
	  END
	  END IF

REM $STATIC
SUB Acceptuser (acceptfile$, Baudrate$, Username$, deny%)
CALL exist(acceptfile$ + CHR$(0), found%)
  IF NOT found% THEN
	 deny% = 0
	 EXIT SUB
  END IF
ff = FREEFILE
OPEN acceptfile$ FOR INPUT AS ff
WHILE NOT EOF(ff)
  LINE INPUT #ff, ln$
  IF LTRIM$(UCASE$(ln$)) = "ACCEPT " + Baudrate$ THEN
	DO
	LINE INPUT #ff, name$
	 IF LTRIM$(UCASE$(Username$)) = LTRIM$(UCASE$(name$)) THEN
	deny% = 0
	CLOSE ff
	EXIT SUB
	 END IF
	LOOP UNTIL UCASE$(name$) = "END"
	deny% = -1
	CLOSE ff
	EXIT SUB
  END IF
WEND
CLOSE ff
END SUB

SUB Box (TRow%, BRow%, LCol%, RCol%, f%, B%) STATIC

COLOR f%, B%
wide% = RCol% - LCol%
Hgt% = BRow% - TRow%

LOCATE TRow%, LCol%
PRINT "" + STRING$(wide% - 1, 196) + ""
FOR D = 1 TO Hgt% - 1
  LOCATE TRow% + D, LCol%
  PRINT "" + SPACE$(wide% - 1) + ""
NEXT D
LOCATE BRow%, LCol%
PRINT "" + STRING$(wide% - 1, 196) + "";

END SUB

SUB ColorConfig STATIC

Box 2, 24, 2, 79, 15, 1
LOCATE 2, 24
PRINT "  Tracker! " + ver$ + " Color Configuration  "
LOCATE 24, 9
PRINT "  (C) 1989, Cory Wright - The Rising Connection  (615) 531-8789  ";

Box 11, 22, 5, 76, 8, 0

LOCATE 22, 11
COLOR 7
PRINT " Colors: ";
FOR A = 1 TO 15
  COLOR A
  PRINT A;
NEXT A

LOCATE 11, 57
COLOR 8: PRINT "["; : COLOR bright: PRINT "User Information"; : COLOR 8: PRINT "]"
LOCATE 12, 7
COLOR 7: PRINT "User Name:  "; : COLOR info: PRINT "Thomas Jefferson"
LOCATE 13, 19: COLOR 7: PRINT "User 1    Level 0"; TAB(50);
COLOR bright: PRINT "Sysop Override"
LOCATE 14, 7: COLOR info: PRINT "Ansi On"; TAB(19); : COLOR 7: PRINT "Output to "; : COLOR info: PRINT "COM1:"; : COLOR 7: PRINT " @ "; : COLOR info: PRINT "9600"; : COLOR 7: PRINT " baud."; TAB(50);
COLOR 7: PRINT "Message Index Done"
COLOR 8: LOCATE 15, 5: PRINT "" + STRING$(70, 196) + ""
LOCATE 17, 9: COLOR info: PRINT "Connected at 9600 baud at 4:58 pm on Tuesday, December 19, 1989."
LOCATE 18, 7: COLOR border: PRINT STRING$(68, 196)
LOCATE 19, 9: COLOR bright: PRINT "Thomas"; : COLOR text: PRINT ", you are caller "; : COLOR bright: PRINT "14"; : COLOR text: PRINT " and #"; : COLOR bright: PRINT "4998"; : COLOR text: PRINT " to date."
LOCATE 20, 9: COLOR bright: PRINT "Cory Wright"; : COLOR text: PRINT " from "; : COLOR bright: PRINT "Knoxville, TN"; : COLOR text: PRINT " was the last person on."


COLOR 14, 1
LOCATE 4, 5
PRINT "Please press the letter to change:"; TAB(42); : COLOR 12: PRINT "[Esc] to abort entry"; TAB(65); : COLOR 10: PRINT "[Q] to quit"

LOCATE 6, 9
COLOR 15: PRINT "("; : COLOR 12: PRINT "B"; : COLOR 15: PRINT ")order Color"; TAB(40); : COLOR 11: PRINT LTRIM$(STR$(border))
LOCATE 7, 9
COLOR 15: PRINT "("; : COLOR 12: PRINT "T"; : COLOR 15: PRINT ")ext Color"; TAB(40); : COLOR 11: PRINT LTRIM$(STR$(text))
LOCATE 8, 9
COLOR 15: PRINT "("; : COLOR 12: PRINT "H"; : COLOR 15: PRINT ")ighlight Color"; TAB(40); : COLOR 11: PRINT LTRIM$(STR$(bright))
LOCATE 9, 9
COLOR 15: PRINT "("; : COLOR 12: PRINT "G"; : COLOR 15: PRINT ")eneral Information Color"; TAB(40); : COLOR 11: PRINT LTRIM$(STR$(info))

201 SELECT CASE UCASE$(INKEY$)
	 CASE "B"
	   valid$ = "0123456789"
	   inbuff$ = SPACE$(2)
	   IF QINPUT(valid$, inbuff$, 6, 40, QATTR(0, 11), 0, 1) = 1 THEN
	  tmp = VAL(RTRIM$(inbuff$))
	  IF tmp < 1 OR tmp > 15 THEN
		LOCATE 6, 45
		COLOR 12: BEEP: BEEP
		PRINT "Invalid Color Choice!"; ""
		SLEEP (2)
	  ELSE
		border = tmp
	  END IF
	ELSE
	  ColorConfig
	   END IF
	   ColorConfig
	 CASE "T"
	   valid$ = "0123456789"
	   inbuff$ = SPACE$(2)
	   IF QINPUT(valid$, inbuff$, 7, 40, QATTR(0, 11), 0, 1) = 1 THEN
	  tmp = VAL(RTRIM$(inbuff$))
	  IF tmp < 1 OR tmp > 15 THEN
		LOCATE 7, 45
		COLOR 12: BEEP: BEEP
		PRINT "Invalid Color Choice!"; ""
		SLEEP (2)
	  ELSE
		text = tmp
	  END IF
	ELSE
	  ColorConfig
	   END IF
	   ColorConfig
	 CASE "H"
	   valid$ = "0123456789"
	   inbuff$ = SPACE$(2)
	   IF QINPUT(valid$, inbuff$, 8, 40, QATTR(0, 11), 0, 1) = 1 THEN
	  tmp = VAL(RTRIM$(inbuff$))
	  IF tmp < 1 OR tmp > 15 THEN
		LOCATE 8, 45
		COLOR 12: BEEP: BEEP
		PRINT "Invalid Color Choice!"; ""
		SLEEP (2)
	  ELSE
		bright = tmp
	  END IF
	ELSE
	  ColorConfig
	   END IF
	   ColorConfig
	 CASE "G"
	   valid$ = "0123456789"
	   inbuff$ = SPACE$(2)
	   IF QINPUT(valid$, inbuff$, 9, 40, QATTR(0, 11), 0, 1) = 1 THEN
	  tmp = VAL(RTRIM$(inbuff$))
	  IF tmp < 1 OR tmp > 15 THEN
		LOCATE 9, 45
		COLOR 12: BEEP: BEEP
		PRINT "Invalid Color Choice!"; ""
		SLEEP (2)
	  ELSE
		info = tmp
	  END IF
	ELSE
	  ColorConfig
	   END IF
	   ColorConfig
	 CASE CHR$(27)
	  Config
	 CASE "Q"
	  Config
	 CASE ""
	  GOTO 201
	 CASE ELSE
	  GOTO 201
	END SELECT

END SUB

SUB Config STATIC
COLOR 15, 0
CLS

Box 8, 16, 2, 79, 15, 1
LOCATE 8, 21
PRINT "  Tracker! " + ver$ + " Configuration - Main Menu  "
LOCATE 16, 9
PRINT "  (C) 1989, Cory Wright - The Rising Connection  (615) 531-8789  ";
COLOR 14
LOCATE 9, 5
PRINT "Please press the letter of your choice:"; TAB(55); : COLOR 10: PRINT "[Q] to quit and save"
LOCATE 11, 9
COLOR 15: PRINT "("; : COLOR 12: PRINT "G"; : COLOR 15: PRINT ")eneral Configuration"
LOCATE 12, 9
COLOR 15: PRINT "("; : COLOR 12: PRINT "M"; : COLOR 15: PRINT ")essage base maintenance"
LOCATE 13, 9
COLOR 15: PRINT "("; : COLOR 12: PRINT "C"; : COLOR 15: PRINT ")olor Configuration"

200 SELECT CASE UCASE$(INKEY$)
	  CASE "C"
	ColorConfig
	Config
	  CASE "G"
	GeneralConfig
	Config
	  CASE "M"
	LOCATE 15, 30
	COLOR 12
	PRINT "Option not yet available"
	SLEEP (2)
	Config
	  CASE ""
	GOTO 200
	  CASE "Q"
	'be sure to save information
	LOCATE 15, 5
	COLOR 14
	PRINT "Saving settings into " + UCASE$(trakcnf$)
	ff = FREEFILE
	OPEN trakcnf$ FOR RANDOM AS ff LEN = LEN(cnf)
	 cnf.bbs = bbs$
	 cnf.crc = usercrc$
	 cnf.mailwait = mailwait$
	 cnf.nomail = nomail$
	 cnf.ratiof = ratiof
	 cnf.ratiok = ratiok
	 cnf.border = border
	 cnf.text = text
	 cnf.bright = bright
	 cnf.info = info
	 cnf.udirpath = udir$
	 PUT ff, 1, cnf
	CLOSE ff
	LOCATE 24, 1
	END
	  CASE ELSE
	GOTO 200
	END SELECT

END
END SUB

4245 SUB CTR (st$)
4250 stlen = LEN(st$)
4255 PRINT SPACE$(38 - (stlen / 2)) + st$
4260 END SUB

SUB DivLine (C%)    ' C% is color to return with
COLOR 8
PRINT STRING$(79, 196)
COLOR C%
END SUB

SUB DropAtBaud (dropbaud$) STATIC

IF showbaud$ = dropbaud$ THEN
  IF INSTR(COMMAND$, "/NO" + dropbaud$) <> 0 THEN
	 CALL exist(acceptfile$ + CHR$(0), gotit%)
	 IF gotit% THEN Acceptuser acceptfile$, showbaud$, whole$, deny%
	 IF deny% THEN
	  ln$ = CRLF$ + hue$(12) + SPACE$(3) + "Connections at " + dropbaud$ + " baud are not currently being accepted." + CRLF$ + SPACE$(3) + "Click!" + CRLF$ + CRLF$
	  Transmit ln$
	  COLOR 12
	  LOCATE 7, 1
	  PRINT SPACE$(6) + "Connections at " + dropbaud$ + " baud are not currently being accepted."
	  PRINT SPACE$(6) + "Click!"
	  DropDTR GTPath$, Port%
	  END
	 END IF
  END IF
END IF

END SUB

SUB DropDTR (GTPath$, Port%)

SHELL GTPath$ + "dropdtr" + LTRIM$(STR$(Port%)) + ".exe"

END SUB

SUB EnterMSG (GTPath$, subj$, day%, msgfile$)
	 'parse GT.CNF to find sysop base
	 OPEN GTPath$ + "GT.CNF" FOR INPUT AS 8
	 DO WHILE NOT EOF(8)
	 LINE INPUT #8, ln$
	 IF LEFT$(ln$, 3) = "SM=" THEN
	sysmsg$ = RIGHT$(ln$, LEN(ln$) - 3)
	EXIT DO
	 END IF
	 LOOP
	 IF RIGHT$(sysmsg$, 1) <> "\" THEN sysmsg$ = sysmsg$ + "\"
	 CLOSE 8
	 'open SYSOP.BBS to find sysop name
	 OPEN GTPath$ + "SYSOP.BBS" FOR INPUT AS 8
	 FOR x = 1 TO 3
	 LINE INPUT #8, ln$
	 NEXT x
	 sysopname$ = ln$
	 CLOSE 8
	 'open message in base
	 OPEN sysmsg$ + "MESSAGE.CTL" FOR RANDOM AS 8 LEN = LEN(msg)
	 lastmsg = LOF(8) / LEN(msg)
	 GET 8, lastmsg, msg
	  msg.deleted = CHR$(0)
	  msg.msgnumber = msg.msgnumber + 1
	  msg.sender = "Tracker 1.37" + CHR$(0)
	  msg.whoto = LEFT$(sysopname$, 30) + CHR$(0)
	  msg.subj = subj$ + CHR$(0)
	mdate$ = DATE$
	mdate$ = LEFT$(mdate$, 6) + RIGHT$(mdate$, 2)
	  IF LEFT$(mdate$, 1) = "0" THEN mdate$ = RIGHT$(mdate$, LEN(mdate$) - 1)
	  msg.msgdate = mdate$ + CHR$(0)
	mtime$ = LEFT$(TIME$, 5)
	IF LEFT$(mtime$, 1) = "0" THEN mtime$ = SPACE$(1) + RIGHT$(mtime$, 4)
	  msg.msgtime = mtime$ + CHR$(0)
	  msg.weekday = CHR$(day%)
	  msg.destnet = 0
	  msg.destnode = 0
	  msg.priv = CHR$(1)
	  msg.recv = CHR$(0)
	 PUT 8, lastmsg + 1, msg
	 CLOSE 8
	 newmsg = msg.msgnumber
	 IF newmsg > 0 AND newmsg < 10 THEN msgfile$ = sysmsg$ + "GTMSGS\0000" + LTRIM$(STR$(newmsg)) + ".MSG"
	 IF newmsg >= 10 AND newmsg < 100 THEN msgfile$ = sysmsg$ + "GTMSGS\000" + LTRIM$(STR$(newmsg)) + ".MSG"
	 IF newmsg >= 100 AND newmsg < 1000 THEN msgfile$ = sysmsg$ + "GTMSGS\00" + LTRIM$(STR$(newmsg)) + ".MSG"
	 IF newmsg >= 1000 AND newmsg < 10000 THEN msgfile$ = sysmsg$ + "GTMSGS\0" + LTRIM$(STR$(newmsg)) + ".MSG"
	 IF newmsg > 10000 THEN msgfile$ = sysmsg$ + "GTMSGS\" + LTRIM$(STR$(newmsg)) + ".MSG"
END SUB

SUB FixTime (timeconv$, newtime$)
'fix time
 CALL times2n(hour%, min%, sec%, timeconv$)
 IF hour% > 12 THEN
	 hour% = hour% - 12
	 pm = -1
2223 END IF
 IF hour% = 12 THEN pm = -1
 IF hour% >= 10 OR hour% = 0 THEN spacing$ = SPACE$(9) ELSE spacing$ = SPACE$(10)
 timeconv$ = SPACE$(8)
 CALL timen2s(hour%, min%, sec%, timeconv$)
 timeconv$ = LTRIM$(RTRIM$(timeconv$))
 IF LEFT$(timeconv$, 2) = "00" THEN timeconv$ = "12" + MID$(TIME$, 3, 3)
 IF LEFT$(timeconv$, 1) = "0" THEN timeconv$ = MID$(timeconv$, 2, 4) + " " ELSE timeconv$ = LEFT$(timeconv$, 5) + " "
 IF pm = -1 THEN timeconv$ = timeconv$ + "pm" ELSE timeconv$ = timeconv$ + "am"
 newtime$ = timeconv$
END SUB

SUB GeneralConfig STATIC

Box 2, 24, 2, 79, 15, 1
LOCATE 2, 22
PRINT "  Tracker! " + ver$ + " General Configuration  "
LOCATE 24, 9
PRINT "  (C) 1989, Cory Wright - The Rising Connection  (615) 531-8789  ";

COLOR 14
LOCATE 4, 5
	
PRINT "Please press the letter to change:"; TAB(43); : COLOR 12: PRINT "[Esc] aborts entry"; TAB(65); : COLOR 10: PRINT "[Q] to quit"
LOCATE 6, 5
COLOR 15: PRINT "("; : COLOR 12: PRINT "B"; : COLOR 15: PRINT ")BS name:"
LOCATE 7, 5: COLOR 11: PRINT bbs$
LOCATE 9, 5
COLOR 15: PRINT "("; : COLOR 12: PRINT "C"; : COLOR 15: PRINT ")RC:"; TAB(12); : COLOR 11: PRINT usercrc$
LOCATE 11, 5
COLOR 15: PRINT "("; : COLOR 12: PRINT "M"; : COLOR 15: PRINT ")ail Header:"
LOCATE 12, 5: COLOR 11: PRINT mailwait$
LOCATE 14, 5
COLOR 15: PRINT "("; : COLOR 12: PRINT "N"; : COLOR 15: PRINT ")o-Mail Header:"
LOCATE 15, 5: COLOR 11: PRINT nomail$
LOCATE 17, 5
COLOR 15: PRINT "("; : COLOR 12: PRINT "F"; : COLOR 15: PRINT ")ile ratio:"; TAB(24); : COLOR 11: PRINT LTRIM$(STR$(ratiof)); TAB(30); : COLOR 15: PRINT "files downloaded to 1 file uploaded"
LOCATE 18, 5
COLOR 15: PRINT "("; : COLOR 12: PRINT "K"; : COLOR 15: PRINT ")ilobyte ratio:"; TAB(24); : COLOR 11: PRINT LTRIM$(STR$(ratiok)) + "K"; TAB(30); : COLOR 15: PRINT "downloaded to 1K uploaded"
LOCATE 20, 5
COLOR 15: PRINT "("; : COLOR 12: PRINT "P"; : COLOR 15: PRINT ")ath to Temp files:"; TAB(28); : COLOR 11: PRINT udir$


202 SELECT CASE UCASE$(INKEY$)
	  CASE "B"
	   valid$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"
	   valid$ = valid$ + " -=+\|`~!@#$%^&*()_[]{}:;'?/>.<," + CHR$(34)
	   inbuff$ = bbs$ + SPACE$(74 - LEN(bbs$))
	   IF QINPUT(valid$, inbuff$, 7, 5, QATTR(0, 11), 0, 1) = 1 THEN
	  bbs$ = RTRIM$(inbuff$)
	ELSE
	  GeneralConfig
	   END IF
	   GeneralConfig
	  CASE "C"
	   valid$ = "0123456789ABCDEF-"
	   inbuff$ = usercrc$
	   IF QINPUT(valid$, inbuff$, 9, 12, QATTR(0, 11), 0, 1) = 1 THEN
	  usercrc$ = UCASE$(RTRIM$(inbuff$))
	ELSE
	  GeneralConfig
	   END IF
	   GeneralConfig
	  CASE "M"
	   valid$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"
	   valid$ = valid$ + " -=+\|`~!@#$%^&*()_[]{}:;'?/>.<," + CHR$(34)
	   inbuff$ = mailwait$ + SPACE$(74 - LEN(mailwait$))
	   IF QINPUT(valid$, inbuff$, 12, 5, QATTR(0, 11), 0, 1) = 1 THEN
	  mailwait$ = RTRIM$(inbuff$)
	ELSE
	  GeneralConfig
	   END IF
	   GeneralConfig
	  CASE "N"
	   valid$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"
	   valid$ = valid$ + " -=+\|`~!@#$%^&*()_[]{}:;'?/>.<," + CHR$(34)
	   inbuff$ = nomail$ + SPACE$(74 - LEN(nomail$))
	   IF QINPUT(valid$, inbuff$, 15, 5, QATTR(0, 11), 0, 1) = 1 THEN
	  nomail$ = RTRIM$(inbuff$)
	ELSE
	  GeneralConfig
	   END IF
	   GeneralConfig
	  CASE "F"
	   valid$ = "0123456789"
	   inbuff$ = SPACE$(4)
	   IF QINPUT(valid$, inbuff$, 17, 24, QATTR(0, 11), 0, 1) = 1 THEN
	  ratiof = VAL(RTRIM$(inbuff$))
	ELSE
	  GeneralConfig
	   END IF
	   GeneralConfig
	  CASE "K"
	   valid$ = "0123456789"
	   inbuff$ = SPACE$(4)
	   IF QINPUT(valid$, inbuff$, 18, 24, QATTR(0, 11), 0, 1) = 1 THEN
	  ratiok = VAL(RTRIM$(inbuff$))
	ELSE
	  GeneralConfig
	   END IF
	   GeneralConfig
	  CASE "P"
	   valid$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"
	   valid$ = valid$ + " -=+\|`~!@#$%^&*()_[]{}:;'?/>.<," + CHR$(34)
	   inbuff$ = udir$ + SPACE$(40 - LEN(udir$))
	   IF QINPUT(valid$, inbuff$, 20, 28, QATTR(0, 11), 0, 1) = 1 THEN
	  udir$ = LCASE$(RTRIM$(inbuff$))
	  IF RIGHT$(udir$, 1) <> "\" THEN udir$ = udir$ + "\"
	ELSE
	  GeneralConfig
	   END IF
	   GeneralConfig
	  CASE ""
	GOTO 202
	  CASE "Q"
	Config
	  CASE CHR$(27)
	Config
	  CASE ELSE
	GOTO 202
	END SELECT


END SUB

SUB Init

' Init
2300 OPEN userctl$ FOR RANDOM AS 1 LEN = 176
2305 ons = 0
2310 recs = LOF(1) / LEN(user)

ParseUser
CALL Box(7, 14, 9, 67, INT(border), 0)
LOCATE 7, 11
PRINT "["; : COLOR info: PRINT "Tracker! " + ver$ + " Initialization"; : COLOR border: PRINT "]"
IF INSTR(COMMAND$, "/OVERRIDE") <> 0 THEN
 LOCATE 19
 COLOR bright
 CTR "/OVERRIDE specified: All level 0 users' calls will be added to total."
END IF

2375 COLOR text
2380 LOCATE 9, 14
2385 PRINT " User"
2390 LOCATE 10, 14
2395 PRINT "Calls"
2400 LOCATE 11, 14
2405 PRINT "Total"

2410 FOR A = 2 TO recs
2415 GET 1, A, user
2420 LOCATE 9, 21
2425 PRINT STR$(A - 1) + " - " + user.whole
2430 IF LEFT$(user.whole, LEN(whole$)) = whole$ THEN locale$ = user.location
2435 ons = user.timeson
2440 LOCATE 10, 21
2445 IF user.deleted = CHR$(1) OR user.banned = CHR$(1) THEN
2450    PRINT " Skipping...";
2455    FOR sd = 1 TO 750: NEXT sd    'small delay
2460    LOCATE 10, 21
2465    PRINT SPACE$(12);
2470    GOTO 2530
2475 END IF

2476 IF INSTR(COMMAND$, "/OVERRIDE") <> 0 THEN
2477 IF LEFT$(user.level, 1) = "0" THEN user.level = "1"
2478 END IF
2480 IF LEFT$(user.level, 1) <> "0" THEN
2485    Total = Total + ons
2490    PRINT ons;
2495 ELSE
2500    PRINT " Skipping...";
2505    FOR sd = 1 TO 750: NEXT sd    'small delay
2510    LOCATE 10, 21
2515    PRINT SPACE$(12);
2520    GOTO 2530
2525 END IF
2530 LOCATE 11, 21
2535 PRINT Total
2540 NEXT A
2545 CLOSE 1

2550 COLOR info
2555 LOCATE 13, 12
2560 PRINT "Writing TRAK.BBS Control File in " + UCASE$(GTPath$)

2565 OPEN gtrack$ FOR OUTPUT AS 2
2570 PRINT #2, LTRIM$(STR$(Total))
2575 PRINT #2, "The Maintenance System"
2580 PRINT #2, "Tracker!"
2585 PRINT #2, DATE$
2590 PRINT #2, "0"
2595 PRINT #2, STR$(A)
	 PRINT #2, TIME$
	 PRINT #2, "A"
2600 CLOSE 2
2605 LOCATE 20, 1
2610 END

END SUB

SUB LoadMessageBases STATIC
 nf = FREEFILE
 OPEN ptmdir$ FOR RANDOM AS nf LEN = LEN(mdir)   'load in message bases
 totalbases = LOF(1) / LEN(mdir)
   FOR B = 1 TO totalbases
	 GET 1, B, mdir       'pick up base level,path and description
	 base$(B) = LTRIM$(RTRIM$(mdir.mbase)) + "MESSAGE.CTL"
	 desc$(B) = LTRIM$(RTRIM$(mdir.mdesc))
	 mlevel$(B) = mdir.mlevel
	 mlocal(B) = ASC(mdir.mlocal)
   NEXT B
 CLOSE 1

END SUB

SUB Logoff STATIC
	 
CLS
COLOR info
3779 CTR "Tracker! " + ver$ + "  (End-of-Call Message Rescan)"
'if TMAIL.CTL doesn't exist, then exit
3780 CALL exist(tmail$ + CHR$(0), here%)
3785 IF NOT here% THEN
3795   CTR "Tracker! not executed upon logon, assumed incomplete logon sequence."
3800   END
3805 END IF
	 ParseUser

' verify that they've read what's there
LoadMessageBases
3515 COLOR 14
3520 CTR "Composing " + whole$ + "'s mail history."
	 COLOR border: PRINT STRING$(79, 196)
3525 LOCATE 24, 1: PRINT STRING$(79, 196);
	 VIEW PRINT 4 TO 23
CALL exist(pending$ + CHR$(0), pthere%)
IF pthere% THEN
3585 OPEN pending$ FOR RANDOM AS 1 LEN = LEN(pendingctl)  'look for pending mail
3615 pendinglen = LOF(1) / LEN(pendingctl)
	 PRINT "pendinglen--(pendingctl)="; STR$(pendinglen)
3590 FOR w = 1 TO pendinglen
3595 GET 1, w, pendingctl
3600 Areainfo(w) = pendingctl.area   'put waiting areas in array
3605 msgrec(w) = pendingctl.msgrec   ' "   "  msg record in array
	 trakrec(w) = pendingctl.trakrec ' "   "  tndx record in array
3610 NEXT w

3620 CLOSE
3665 KILL pending$
END IF
	
3625 FOR main = 1 TO pendinglen
	 OPEN trakndx$ FOR RANDOM AS 3 LEN = LEN(tndx)
	 OPEN trakctl$ FOR RANDOM AS 4 LEN = LEN(tctl)
3630 master = Areainfo(main)
3635 msgrecnum = msgrec(main)
	 trakrecnum = trakrec(main)
3640 COLOR text
3650 OPEN base$(master) FOR RANDOM AS 1 LEN = LEN(msg)
3655 Msgs = LOF(1) / LEN(msg)

3670 Start = 2
3675 GET 1, msgrecnum, msg
3680 msgnum = msg.msgnumber
3645 PRINT "Verifying Msg #" + LTRIM$(STR$(msgnum)); TAB(20); "  " + desc$(master)

3685 lastlen = LEN(orgwhole$)
3690 IF (LCASE$(LEFT$(msg.whoto, lastlen))) = LCASE$(orgwhole$) THEN
3695 IF msg.deleted = CHR$(1) THEN 3765
3700 IF msg.recv = CHR$(1) OR msg.recv = CHR$(33) OR msg.recv = CHR$(17) THEN 3765
3705 IF msg.destnode <> 0 OR msg.destnet <> 0 THEN 3765
	 COLOR 12
	 PRINT "   - Message Pending"
3755 GOTO 3770
3760 END IF

3765 GET 3, trakrecnum, tndx
	 tndx.deleted = CHR$(1)
	 PUT 3, trakrecnum, tndx
	 COLOR 12
	 PRINT "   - Marking as 'RECV' in NDX - trakrecnum="; STR$(trakrecnum)
3770 CLOSE
	 NEXT main

'load all users into array
OPEN userctl$ FOR RANDOM AS 6 LEN = LEN(user)
  FOR U = 2 TO LOF(6) / LEN(user)
	GET 6, U, user
	Username$(U) = user.whole
  NEXT U
CLOSE 6
'scan for any new mail left - must scan all
3810 OPEN tmail$ FOR RANDOM AS 5 LEN = LEN(tmailctl)
3815 FOR master = 1 TO totalbases
3820 COLOR text
3825 PRINT "Checking "; : COLOR bright: PRINT LEFT$(desc$(master), 39)
3830 CLOSE 1
3835 OPEN base$(master) FOR RANDOM AS 1 LEN = LEN(msg)
3840 Msgs = LOF(1) / LEN(msg)
3845 GET 5, master, tmailctl
3850 Start = tmailctl.highmsg + 1
3855 FOR z = Start TO Msgs
3860 GET 1, z, msg
3865 msgnum = msg.msgnumber
3870 IF msg.deleted <> CHR$(1) THEN
3895 IF msg.recv = CHR$(1) OR msg.recv = CHR$(17) OR msg.recv = CHR$(33) THEN
3900 Start = z + 1
3905 GOTO 3855
3910 END IF
	 IF msg.destnode <> 0 OR msg.destnet <> 0 THEN
	   Start = z + 1
	   GOTO 3855
	 END IF
'analyze message header
	 COLOR bright
	 towho$ = LTRIM$(RTRIM$(msg.whoto))
	 IF LCASE$(towho$) = "all" THEN
	  Start = z + 1
	  GOTO 3855
	 END IF
'see if addressee is user
	 OPEN userctl$ FOR RANDOM AS 6 LEN = LEN(user)
	 C = 1   'skip SYS CTL
	 DO WHILE C < NumberUsers
	C = C + 1
	Userfound = false
	GET 6, C, user
	IF msg.whoto = user.whole THEN
	  Userrecord = C
	  Userfound = true
	  EXIT DO
	END IF
	 LOOP
	 CLOSE 6
	 IF Userfound = true THEN
	  OPEN trakndx$ FOR RANDOM AS 3 LEN = LEN(tndx)
	  OPEN trakctl$ FOR RANDOM AS 4 LEN = LEN(tctl)
	   tndx.usernumber = Userrecord
	   tndx.trecord = (LOF(4) / LEN(tctl)) + 1
	   tndx.deleted = CHR$(0)
	   tctl.area = master
	   tctl.msg = msg.msgnumber
	   tctl.msgrecord = z
	   tctl.from = LEFT$(msg.sender, INSTR(msg.sender, CHR$(0)))
	   tctl.subj = LEFT$(msg.subj, INSTR(msg.subj, CHR$(0)))
	   nextndx = (LOF(3) / LEN(tndx)) + 1
	   PUT 3, nextndx, tndx
	   PUT 4, tndx.trecord, tctl
	  CLOSE 3, 4
	
	 ELSE
	   COLOR 12
	   PRINT " - REJECT: Addressee not in user base"
	   Start = z + 1
	   GOTO 3855
	 END IF
4035 COLOR info
	 naught = INSTR(msg.whoto, CHR$(0))
	 IF naught THEN rawtowho$ = LEFT$(msg.whoto, naught) ELSE rawtowho$ = msg.whoto
4040 PRINT " - New Message for "; rawtowho$
4075 Start = z + 1
4080 GOTO 3855
4085 END IF
4090 NEXT z
4095 NEXT master
4100 CLOSE
4105 KILL tmail$
VIEW PRINT 1 TO 25
' find mins on and prepare to write bulletin
ZF = FREEFILE
OPEN gtrack$ FOR INPUT AS ZF
LINE INPUT #ZF, totalcall$  'skip umimportant stuff.
LINE INPUT #ZF, laston$  'skip umimportant stuff.
LINE INPUT #ZF, city$  'skip umimportant stuff.
LINE INPUT #ZF, today$  'skip umimportant stuff.
LINE INPUT #ZF, calltoday$  'skip umimportant stuff.
LINE INPUT #ZF, userrec$  'skip umimportant stuff.
LINE INPUT #ZF, logtime$
CLOSE ZF

' this breaks down the time
4160 CALL times2n(hour%, min%, sec%, logtime$)
4165 tim$ = TIME$
4170 CALL times2n(hour2%, min2%, sec2%, tim$)
' fix 00 to 24 and subtract times
4175 IF hour% = 23 AND hour2% = 0 THEN hour2% = 24
4180 Fhour% = hour2% - hour%
4185 Fmin% = min2% - min%
4190 Ftime% = (Fhour% * 60) + Fmin%   'final time
LOCATE 4, 50
COLOR text
PRINT "Time on = ";
COLOR bright
PRINT LTRIM$(STR$(Ftime%))

4130 IF level$ = "0" THEN
4135    COLOR text: LOCATE 6, 50
4140    PRINT "SysOp: No WHOTODAY.?BS entry"
	'update SYSOP time on
	OPEN trakt$ FOR RANDOM AS 12 LEN = LEN(traktime)
	GET 12, day%, traktime
	traktime.stime = traktime.stime + Ftime%
	PUT 12, day%, traktime
	CLOSE
	LOCATE 24, 1
4145    END
4150 END IF

'if it gets this far, then USER is on
OPEN trakt$ FOR RANDOM AS 12 LEN = LEN(traktime)
GET 12, day%, traktime
IF override = false THEN
  traktime.utime = traktime.utime + Ftime%
ELSE
  traktime.stime = traktime.stime + Ftime%
END IF
PUT 12, day%, traktime
CLOSE 12

' prepare bulletin
IF today$ = DATE$ THEN
4200 OPEN tbullb$ FOR APPEND AS 6
4205 OPEN tbullc$ FOR APPEND AS 7
END IF

' append body of bulletin
COLOR text
LOCATE 6, 50
PRINT "Adding user to WHOTODAY.?BS"
FixTime logtime$, timeon$
timeoff$ = timeconv$

' fix spacing in time for bulletin
IF MID$(timeon$, 2, 1) = ":" THEN timeon$ = SPACE$(1) + timeon$
IF MID$(timeoff$, 2, 1) = ":" THEN timeoff$ = SPACE$(1) + timeoff$

4225 PRINT #6, SPACE$(2) + LEFT$(laston$, 20); TAB(24); LEFT$(city$, 25); TAB(50); timeon$; TAB(61); timeoff$; TAB(73); LTRIM$(STR$(Ftime%))
4230 PRINT #7, CHR$(27) + "[1;37m" + SPACE$(2) + LEFT$(laston$, 20); TAB(30); LEFT$(city$, 25); TAB(56); timeon$; TAB(67); timeoff$; TAB(79); LTRIM$(STR$(Ftime%)); CHR$(27) + "[0m"
CLOSE
COLOR text
CALL exist(GTPath$ + "YESMAIL.TRC" + CHR$(0), there%)
IF there% THEN
   KILL GTPath$ + "YESMAIL.TRC"
   LOCATE 8, 50
   PRINT "YESMAIL.TRC deleted."
END IF
CALL exist(GTPath$ + "NOMAIL.TRC" + CHR$(0), there2%)
IF there2% THEN
   KILL GTPath$ + "NOMAIL.TRC"
   LOCATE 8, 50
   PRINT "NOMAIL.TRC deleted."
END IF
CALL exist(whodis$ + CHR$(0), f%)
IF f% THEN KILL whodis$

LOCATE 24, 1
END

END SUB

SUB MScan STATIC   'for breaking down GTMDIR.BBS

'start GTMDIR breakdown
CALL exist(gtmdir$ + CHR$(0), there%)
IF NOT there% THEN
  BEEP
  COLOR 12
  PRINT "ERROR:  GTMDIR.BBS not present in GTPath!  Aborting."
  BEEP: BEEP
  END
END IF

OPEN ptmdir$ FOR RANDOM AS 4 LEN = LEN(mdir)
OPEN gtmdir$ FOR INPUT AS 5
 WHILE NOT EOF(5)
  LINE INPUT #5, cline$
  IF LEFT$(cline$, 1) = "" OR LEFT$(cline$, 1) = " " THEN 12000
  words = QWORDS(cline$)
  IF words < 3 THEN 12000
  basecount = basecount + 1
 FOR A = 1 TO words
  IF QWORD(cline$, A, strt%, Slen%) = 0 THEN Param$(A) = MID$(cline$, strt%, Slen%)
  IF A >= 3 THEN desc$(basecount) = desc$(basecount) + Param$(A) + " "
 NEXT A

 IF INSTR(Param$(2), ":") <> 0 THEN
   base$(basecount) = MID$(Param$(2), INSTR(Param$(2), ":") - 1, LEN(Param$(2)))
   IF RIGHT$(base$(basecount), 1) <> "\" THEN base$(basecount) = base$(basecount) + "\"
 END IF

 IF LEN(Param$(1)) > 1 THEN
   mlevel$(basecount) = RIGHT$(Param$(1), 1)
  ELSE
   mlevel$(basecount) = Param$(1)
 END IF

MStrip desc$(basecount)

IF INSTR(UCASE$(desc$(basecount)), "LOCAL") <> 0 THEN
  mdir.mlocal = CHR$(1)
 ELSE
  mdir.mlocal = CHR$(0)
END IF
  mdir.mlevel = mlevel$(basecount)
  mdir.mbase = base$(basecount)
  mdir.mdesc = desc$(basecount)
 
  PUT 4, basecount, mdir

12000 WEND
CLOSE 4, 5

END SUB

SUB MStrip (desc$) STATIC

 ln$ = desc$
 CALL Striprange(ln$, 36, 38, mlen%)
 ln2$ = LEFT$(ln$, mlen%)
 CALL Striprange(ln2$, 91, 93, mlen2%)
 ln3$ = LEFT$(ln2$, mlen2%)
 CALL Striprange(ln3$, 126, 127, mlen3%)
 ln4$ = LEFT$(ln3$, mlen3%)
 desc$ = ln4$

END SUB

SUB NumberOfUsers STATIC
 
  ff = FREEFILE
  OPEN userctl$ FOR RANDOM AS ff LEN = LEN(user)
   NumberUsers = LOF(ff) / LEN(user)
  CLOSE ff
 
END SUB

SUB ParseUser STATIC

' parse GTUSER.BBS
2615 OPEN gtuser$ FOR INPUT AS 9
2620 LINE INPUT #9, gtus$
2625 CLOSE 9

words% = QWORDS%(gtus$)

FOR y = 1 TO words%
  z% = y
  CALL extract(gtus$, " ", z%, Start%, Slen%)
  Param$(z% - 1) = MID$(gtus$, Start%, Slen%)
NEXT y

'check for 1 word names
2725 IF words% = 9 THEN   ' should be 10 for 2 word names!
2730   Param$(2) = ""
2735   oneword = 1
2740 END IF

2745 IF oneword <> 1 THEN
2750    whole$ = Param$(1) + " " + Param$(2)
2755  ELSE
2760    whole$ = Param$(1)
2765 END IF

	 level$ = Param$(0)
2770 first$ = Param$(1)
2775 Baud$ = Param$(words% - 6)
2780 ansi$ = Param$(words% - 5)
	 logontime$ = Param$(words% - 1)
2785 A$ = Param$(words% - 3) 'time left
2790 B$ = Param$(words% - 2) 'time till event
	 UserTime logontime$

END SUB

SUB Personal (greet$, firstname$) STATIC

occur = INSTR(greet$, "@FIRST@")
IF occur <> 0 THEN  ' there is a @CODE@ in the line
  leftgreet = occur - 1
  rightgreet = LEN(greet$) - leftgreet - 7  'compensate for @CODE@
  greet$ = LEFT$(greet$, leftgreet) + firstname$ + RIGHT$(greet$, rightgreet)
END IF

END SUB

SUB REG (BBSNAME$, Regvalue)

adding = 0
bbslen = LEN(BBSNAME$)
IF bbslen < 6 THEN
	Regvalue = 0
	Registered$ = ""
END IF
FOR A = 1 TO bbslen
ch$ = MID$(BBSNAME$, A, 1)
adding = adding + ASC(ch$)
NEXT A

ch$ = MID$(BBSNAME$, 3, 1)
adding = adding + (INT(ASC(ch$) * 9.14))
ch$ = MID$(BBSNAME$, 2, 1)
adding = adding + (INT(ASC(ch$) * 3.14159))
ch$ = MID$(BBSNAME$, 5, 1)
adding = adding + (INT(ASC(ch$) * 18.2 / 1.15))
ch$ = MID$(BBSNAME$, 1, 1)
adding = INT(adding + (INT(ASC(ch$) * 7.2)))
adding = INT(adding * 5.35 / 1.0775)
Regvalue = adding

END SUB

SUB REG2 (BBSNAME$, Regvalue)

adding = 0
bbslen = LEN(BBSNAME$)
IF bbslen < 6 THEN
	Regvalue = 0
	Registered$ = ""
END IF
FOR A = 1 TO bbslen
ch$ = MID$(BBSNAME$, A, 1)
adding = adding + ASC(ch$)
NEXT A

ch$ = MID$(BBSNAME$, 1, 1)
adding = adding + (INT(ASC(ch$) * 3.21))
ch$ = MID$(BBSNAME$, 4, 1)
adding = adding + (INT(ASC(ch$) * 6.9))
ch$ = MID$(BBSNAME$, 5, 1)
adding = adding + (INT(ASC(ch$) * 9.2 / .87))
ch$ = MID$(BBSNAME$, 2, 1)
adding = INT(adding + (INT(ASC(ch$) * 3.2)))
adding = INT(adding * 8.35 / 1.9875)
Regvalue = adding

END SUB

SUB Scan STATIC

CLS
COLOR 11
2990 CTR "Tracker! " + ver$ + " by Cory Wright - (Comprehensive Message Scan)"
2995 DivLine 7
VIEW PRINT 3 TO 25
3028 PRINT "cd " + LEFT$(GTPath$, (LEN(GTPath$) - 1))
3029 SHELL "cd " + LEFT$(GTPath$, (LEN(GTPath$) - 1))
DivLine INT(info)

PRINT "Clearing & reconstructing " + UCASE$(udir$)
DivLine 7
 IF QCHKDIR(LEFT$(udir$, LEN(udir$) - 1) + CHR$(0)) = 0 THEN
   PRINT "echo Y|del " + udir$ + "*.*"
   SHELL "echo Y|del " + udir$ + "*.*"
  ELSE
   PRINT "md " + LEFT$(udir$, LEN(udir$) - 1)
   SHELL "md " + LEFT$(udir$, LEN(udir$) - 1)
 END IF
CALL exist(trakndx$ + CHR$(0), ndxexist%)
IF ndxexist% THEN
  PRINT "Deleting TRACKER.NDX"
  KILL trakndx$
END IF
CALL exist(trakctl$ + CHR$(0), ctlexist%)
IF ctlexist% THEN
  PRINT "Deleting TRACKER.CTL"
  KILL trakctl$
END IF

ParseUser
'check to see who should be 'locals only' during scan
position = INSTR(COMMAND$, "/LOCAL:")
IF position = 0 THEN 4001   'move on..
Cmdline$ = SPACE$(LEN(COMMAND$))
IF QCMDLINE%(Cmdline$) > 0 THEN
	   tmp$ = MID$(Cmdline$, position, LEN(Cmdline$) - position)
	   cnt = 0
	   DO
		cnt = cnt + 1
		IF cnt > LEN(tmp$) THEN EXIT DO
		ch$ = MID$(tmp$, cnt + 7, 1)
		IF ch$ <> " " OR ch$ <> CHR$(0) THEN locals$ = locals$ + ch$
		IF ch$ = CHR$(32) THEN EXIT DO
	   LOOP
END IF
END
4001 DivLine 14
PRINT "Loading message tables..."
DivLine 7
LoadMessageBases
FOR I = 1 TO totalbases
 COLOR info
 PRINT mlevel$(I);
 COLOR text
 PRINT SPACE$(1) + base$(I); TAB(35);
 COLOR bright
 PRINT LEFT$(desc$(I), 44)
NEXT I
3105 CLOSE
PRINT
DivLine 11
PRINT "Validating user base..."
DivLine 7
here = 1
OPEN userctl$ FOR RANDOM AS 1 LEN = LEN(user)
urecs = LOF(1) / LEN(user)
	 FOR L = 2 TO urecs
3106   GET 1, L, user
	   Uname$ = user.whole
	   stripit Uname$
	   ufile$ = udir$ + RIGHT$(Uname$, 8) + "." + LEFT$(Uname$, 3)
	IF ASC(user.deleted) = 1 OR ASC(user.banned) = 1 THEN
	  reject = reject + 1
	  user.whole = "  SKIP:" + user.whole
	  COLOR 12
	  PRINT user.whole;
	ELSE
	  Accept = Accept + 1
	  COLOR text
	  PRINT SPACE$(7) + LEFT$(user.whole, 20) + "-> " + UCASE$(ufile$);
	  COLOR 15: LOCATE CSRLIN, 1: PRINT "OPEN";
	  OPEN ufile$ FOR RANDOM AS 2 LEN = LEN(userfile)
	   userfile.userlevel = user.level  'user level
	   userfile.usernumber = L          'user record number
	   PUT 2, 1, userfile
	   COLOR 13
	   LOCATE CSRLIN, 1: PRINT "close"
	  CLOSE 2
	  COLOR 7
	   END IF

3107 '  IF here >= 79 THEN
	 '     PRINT
	 '     here = 1
	 '  END IF
	 ' LOCATE CSRLIN, here
	 '  here = here + 20
3108 NEXT L
PRINT : DivLine 15
PRINT LTRIM$(STR$(Accept)); : COLOR 7: PRINT " users accepted, "; : COLOR 15: PRINT LTRIM$(STR$(reject)); : COLOR 7: PRINT " rejected, "; : COLOR 15: PRINT LTRIM$(STR$(reject + Accept)); : COLOR 7: PRINT " total."
DivLine 11

' loop through message bases
PRINT "Initiating Comprehensive Message Scan --";
CALL exist(traksc$ + CHR$(0), there%)
 IF NOT there% THEN
  OPEN traksc$ FOR RANDOM AS 25 LEN = LEN(trakscan)
  PRINT " Creating TRAKSCAN.DAT"
  FOR uh = 1 TO 200
   trakscan.active = 0
   PUT 25, 1, trakscan
  NEXT uh
  CLOSE 25
 ELSEIF INSTR(COMMAND$, "/REPORT") <> 0 THEN
  CALL copyfile(traksc$ + CHR$(0), trakscold$ + CHR$(0), errcode%)
  PRINT " <Standard Reporting Enabled>"
 ELSE
  PRINT " <Reporting not active>"
3114 END IF

	 OPEN trakndx$ FOR RANDOM AS 3 LEN = LEN(tndx)
	 OPEN trakctl$ FOR RANDOM AS 4 LEN = LEN(tctl)
	  ndxptr = 1     'next position to write
	  ctlptr = 1     'next position to write

3110 FOR master = 1 TO totalbases    'loop thru msg bases
	 basenum% = master
3120 COLOR 14: PRINT TAB(8); LEFT$(UCASE$(base$(master)), LEN(base$(master)) - 11); TAB(32); : COLOR 7: PRINT SPACE$(1) + LEFT$(desc$(master), 44)
3125 CLOSE 1
3130 OPEN base$(master) FOR RANDOM AS 1 LEN = LEN(msg)
3135 Msgs = LOF(1) / LEN(msg)
	
	 Start = 2
3145 FOR z = Start TO Msgs

3150 GET 1, z, msg
'3155 LOCATE CSRLIN - 1, 1: COLOR text: PRINT msg.msgnumber

3160 IF msg.deleted <> CHR$(1) THEN
	 totalmsgs& = totalmsgs& + 1
	 ActiveMsgs& = ActiveMsgs& + 1    ' add # active messages
3185 IF msg.recv = CHR$(1) OR msg.recv = CHR$(33) OR msg.recv = CHR$(17) THEN 3370
3205 IF msg.destnode <> 0 OR msg.destnet <> 0 THEN 3370
3225 COLOR 11
holder$ = msg.whoto
stripit holder$
3270 IF LCASE$(holder$) = "all" THEN 3370
	 rawudatafile$ = RIGHT$(holder$, 8) + "." + LEFT$(holder$, 3)
	 CALL exist(udir$ + rawudatafile$ + CHR$(0), checkit%)
	 IF NOT checkit% THEN 3370
3290 Userdatafile$ = udir$ + RIGHT$(holder$, 8) + "." + LEFT$(holder$, 3)
3295 IF LCASE$(Userdatafile$) = udir$ + "." THEN 3370
3315 OPEN Userdatafile$ FOR RANDOM AS 2 LEN = LEN(userfile)
	  GET 2, 1, userfile
	 PRINT "mlocal(master)="; mlocal(master)
	 IF mlocal(master) = 0 THEN     'base is an echo
	  IF INSTR(locals$, userfile.userlevel) <> 0 THEN
			 CLOSE 2
			 GOTO 3370
	  END IF
	 END IF
	  IF ASC(userfile.userlevel) > ASC(mlevel$(master)) THEN  'check base level vs. user level
			 CLOSE 2
			 GOTO 3370
	  END IF
	  tndx.usernumber = userfile.usernumber
	 CLOSE 2
	  tndx.trecord = ctlptr
	  tndx.deleted = CHR$(0)
	  tctl.area = master
	  tctl.msg = msg.msgnumber
	  tctl.msgrecord = z
	  tctl.from = msg.sender
	  tctl.subj = msg.subj
	  PRINT "Msg #" + LTRIM$(STR$(msg.msgnumber)) + " to " + LEFT$(msg.whoto, 15); " (u"; LTRIM$(STR$(tndx.usernumber)); ")";
	  PRINT "a" + STR$(master); " ndxrec="; LTRIM$(STR$(ndxptr)); " ctlrec="; LTRIM$(STR$(ctlptr)); " ndxptr->"; LTRIM$(STR$(tndx.trecord))
	  PUT 3, ndxptr, tndx
	  PUT 4, ctlptr, tctl
	  ndxptr = ndxptr + 1   'increment pointer
	  ctlptr = ctlptr + 1   'increment pointer

3365 END IF
3370 NEXT z

	 IF INSTR(COMMAND$, "/REPORT") <> 0 THEN
	  OPEN LEFT$(base$(master), LEN(base$(master)) - 11) + "USER_MSG.CTL" FOR RANDOM AS 33 LEN = 16
	   usermsgctl = (LOF(33) / 16) - 1
	  CLOSE 33
3109  OPEN traksc$ FOR RANDOM AS 25 LEN = LEN(trakscan)
3371  trakscan.active = ActiveMsgs&   ' place # actives in memory
3372  ActiveMsgs& = 0                 ' reset # actives to 0
	  trakscan.usercount = usermsgctl' place # users in base in memory
	  usermsgctl = 0                 ' reset # users to 0
3373  PUT 25, basenum%, trakscan     ' place the record in TRAKSCAN
3374  CLOSE 25
5678 END IF
3375 NEXT master
	 DivLine 11
3390 CTR STR$(totalmsgs&) + " messages scanned  -  Comprehensive Scan Successful."
	 DivLine 7
	 CLOSE

IF INSTR(COMMAND$, "/REPORT") <> 0 THEN
   CTR "Compiling Message Base Statistical Report"
   DivLine 7
   EnterMSG GTPath$, "Message Base Breakdown", day%, msgfile$
   OPEN msgfile$ FOR OUTPUT AS 1
   PRINT #1, "Tracker! " + ver$ + " by Cory Wright - " + current$ + SPACE$(2) + timeconv$
   PRINT #1, ""
   PRINT #1, "Overall Message Summary"
   PRINT #1, STRING$(79, 196)
   ' find TOTAL msgs
   CALL exist(traksc$ + CHR$(0), there1%)
   CALL exist(trakscold$ + CHR$(0), there2%)
	 IF NOT there1% OR NOT there2% THEN
	  PRINT #1, "Full information not available due to a missing TRAKSCAN data file."
	  PRINT #1, STRING$(79, 196)
	  END
3391 END IF
   OPEN traksc$ FOR RANDOM AS 2 LEN = LEN(trakscan)
   OPEN trakscold$ FOR RANDOM AS 3 LEN = LEN(trakscan)
   'loop thru areas in TRAKSCAN
   UpperBound = LOF(2) / LEN(trakscan)
   FOR J = 1 TO UpperBound
	 GET 2, J, trakscan
	 now = now + trakscan.active
	 nowshort = trakscan.active
	 UserTally(J) = trakscan.usercount
	 ActiveMsg(J) = trakscan.active
	 GET 3, J, trakscan
	 backthen = backthen + trakscan.active
	 backthenshort = trakscan.active

	 nummsgs(J) = nowshort - backthenshort
	 IF nummsgs(J) > 0 THEN
	signs$(J) = "+"
	   ELSE
	signs$(J) = ""
	 END IF
   NEXT J
   CLOSE 2, 3
 
	value = now - backthen
	IF value > 0 THEN
	   sign$ = "+"
	ELSE
	   sign$ = ""
3392 END IF
   PRINT #1, LTRIM$(STR$(now)) + " total messages on THIS scan."
   PRINT #1, LTRIM$(STR$(backthen)) + " total messages on LAST scan."
   PRINT #1, STRING$(78, 196)
   PRINT #1, sign$ + LTRIM$(STR$(now - backthen)) + " overall message fluctuation since last scan."
   PRINT #1, ""
   IF now - backthen = 0 THEN 3393
   PRINT #1, "Individual Message Base Breakdown"
   PRINT #1, STRING$(33, 196)
   FOR flow = 1 TO UpperBound
   PRINT #1, desc$(flow) + ":"
   PRINT #1, SPACE$(3); LTRIM$(STR$(ActiveMsg(flow))) + " active messages."
   IF nummsgs(flow) <> 0 THEN PRINT #1, SPACE$(2); signs$(flow) + LTRIM$((STR$(nummsgs(flow)))) + " message fluctuation since last scan."
   PRINT #1, SPACE$(3); LTRIM$(STR$(UserTally(flow))) + " users joined to this base."
   PRINT #1, ""
   NEXT flow
   PRINT #1, STRING$(79, 196)
   PRINT #1, "Regards,"
   PRINT #1, "Tracker! " + ver$ + " by Cory Wright"
   PRINT #1, "TRC Development - The Rising Connection  615-531-8789  GTNet 070/002"
3393 END IF

PRINT "Deleting all temporary files & removing " + UCASE$(udir$)
'delete temp files
 IF QCHKDIR(LEFT$(udir$, LEN(udir$) - 1) + CHR$(0)) = 0 THEN
   PRINT "echo Y|del " + udir$ + "*.*"
   SHELL "echo Y|del " + udir$ + "*.*"
   PRINT "cd " + LEFT$(GTPath$, (LEN(GTPath$) - 1))
   SHELL "cd " + LEFT$(GTPath$, (LEN(GTPath$) - 1))
   PRINT "rd " + LEFT$(udir$, LEN(udir$) - 1)
   SHELL "rd " + LEFT$(udir$, LEN(udir$) - 1)
 END IF

END

END SUB

SUB stripit (ln$) STATIC

whole3$ = ln$
1735 CALL extract(whole3$, CHR$(0), 1, Start%, slen2%)
1740 whole4$ = MID$(whole3$, Start%, slen2%)
	 CALL Striprange(whole4$, 0, 47, mlen2%)
	 whole5$ = LEFT$(whole4$, mlen2%)
	 CALL Striprange(whole5$, 58, 63, mlen3%)
	 whole6$ = LEFT$(whole5$, mlen3%)
	 CALL Striprange(whole6$, 91, 96, mlen4%)
	 whole7$ = LEFT$(whole6$, mlen4%)
	 CALL Striprange(whole7$, 123, 255, mlen5%)
	 whole8$ = LEFT$(whole7$, mlen5%)

ln$ = whole8$
END SUB

SUB UserTime (logontime$) STATIC

'TIME ANALYSIS - "a" is always smallest time left

 tillevent = VAL(B$)
 normalmin = VAL(A$)

 currenthour = VAL(MID$(TIME$, 1, 2))
 currentmin = VAL(MID$(TIME$, 4, 2))

 IF LEN(logontime$) = 4 THEN
	 logmin = VAL(MID$(logontime$, 3, 2))
	 loghour = VAL(LEFT$(logontime$, 1))
 END IF

 IF LEN(logontime$) = 5 THEN
	 logmin = VAL(MID$(logontime$, 4, 2))
	 loghour = VAL(MID$(logontime$, 1, 2))
 END IF

 IF loghour = 24 THEN loghour = 0
 current = (currenthour * 60) + currentmin
 logon = (loghour * 60) + logmin

 timesofar = INT(current - logon)
 IF timesofar < 0 THEN timesofar = 0

 IF tillevent <= normalmin THEN
	 A = tillevent
	 A = A - 6
	 event = 1
 END IF
 IF tillevent > normalmin THEN
	 A = normalmin
	 event = 0
 END IF
 timeleft$ = LTRIM$(STR$(A - timesofar))

END SUB

SUB Validate (ln$, code) STATIC

'ln$ is line to check; code is passed to sub for verification

REG2 ln$, keyval    'check validity of line

'IF keyval <> code THEN
'   BEEP:  BEEP: BEEP
'   CLS
'   COLOR 28
'   LOCATE 14, 1
'   CTR "ALERT: TRACKER'S CODE HAS BEEN CORRUPTED! Please inform author!"
'   BEEP:  BEEP: BEEP
'   END
'END IF

END SUB

SUB WeeklyStat STATIC
	EnterMSG GTPath$, "BBS Statistical Information", day%, msgfile$
	 OPEN trakt$ FOR RANDOM AS 9 LEN = LEN(traktime)
	 FOR J = 1 TO 7
	  GET 9, J, traktime
	  uc(J) = traktime.ucall
	  sc(J) = traktime.scall
	  ut(J) = traktime.utime
	  st(J) = traktime.stime
	  dy(J) = traktime.day
	 NEXT J
	 CLOSE 9
	 'calculate stats
	 FOR J = 1 TO 7
	  totalucalls = totalucalls + uc(J)
	  totalscalls = totalscalls + sc(J)
	  totalutime = totalutime + ut(J)
	  totalstime = totalstime + st(J)
	  daypercent(J) = INT((ut(J) + st(J)) / 1440 * 100)
	 NEXT J
	 totaltime = totalutime + totalstime
	 weekpercent = INT(totaltime / 10080 * 100)
	 OPEN msgfile$ FOR OUTPUT AS 8
	 ln$ = "Statistical Analysis of BBS Performance over the past week"
	 PRINT #8, SPACE$(39 - (LEN(ln$) / 2)) + ln$
	 PRINT #8, STRING$(79, 196)
	 PRINT #8, "           User      Sysop     User     Sysop"
	 PRINT #8, "           Calls     Calls     Time     Time"
	 PRINT #8, STRING$(79, 196)
	 PRINT #8, ""
	 PRINT #8, " Sun " + LTRIM$(STR$(dy(1))); TAB(12); LTRIM$(STR$(uc(1))); TAB(22); LTRIM$(STR$(sc(1))); TAB(32); LTRIM$(STR$(ut(1))); TAB(41); LTRIM$(STR$(st(1)))
	 PRINT #8, " Mon " + LTRIM$(STR$(dy(2))); TAB(12); LTRIM$(STR$(uc(2))); TAB(22); LTRIM$(STR$(sc(2))); TAB(32); LTRIM$(STR$(ut(2))); TAB(41); LTRIM$(STR$(st(2)))
	 PRINT #8, " Tue " + LTRIM$(STR$(dy(3))); TAB(12); LTRIM$(STR$(uc(3))); TAB(22); LTRIM$(STR$(sc(3))); TAB(32); LTRIM$(STR$(ut(3))); TAB(41); LTRIM$(STR$(st(3)))
	 PRINT #8, " Wed " + LTRIM$(STR$(dy(4))); TAB(12); LTRIM$(STR$(uc(4))); TAB(22); LTRIM$(STR$(sc(4))); TAB(32); LTRIM$(STR$(ut(4))); TAB(41); LTRIM$(STR$(st(4)))
	 PRINT #8, " Thu " + LTRIM$(STR$(dy(5))); TAB(12); LTRIM$(STR$(uc(5))); TAB(22); LTRIM$(STR$(sc(5))); TAB(32); LTRIM$(STR$(ut(5))); TAB(41); LTRIM$(STR$(st(5)))
	 PRINT #8, " Fri " + LTRIM$(STR$(dy(6))); TAB(12); LTRIM$(STR$(uc(6))); TAB(22); LTRIM$(STR$(sc(6))); TAB(32); LTRIM$(STR$(ut(6))); TAB(41); LTRIM$(STR$(st(6)))
	 PRINT #8, " Sat " + LTRIM$(STR$(dy(7))); TAB(12); LTRIM$(STR$(uc(7))); TAB(22); LTRIM$(STR$(sc(7))); TAB(32); LTRIM$(STR$(ut(7))); TAB(41); LTRIM$(STR$(st(7)))
	 PRINT #8, STRING$(79, 196)
	 PRINT #8, " Totals"; TAB(12); LTRIM$(STR$(totalucalls)); TAB(22); LTRIM$(STR$(totalscalls)); TAB(32); LTRIM$(STR$(totalutime)); TAB(41); LTRIM$(STR$(totalstime))
	 PRINT #8, STRING$(79, 196)
	 PRINT #8, " Board Loading Detail"
	 PRINT #8, " --------------------"
	 PRINT #8, "    Sunday " + LTRIM$(STR$(dy(1))); TAB(15); "- " + LTRIM$(STR$(ut(1) + st(1))) + " minutes used - approx. " + LTRIM$(STR$(daypercent(1))) + "% usage."
	 PRINT #8, "    Monday " + LTRIM$(STR$(dy(2))); TAB(15); "- " + LTRIM$(STR$(ut(2) + st(2))) + " minutes used - approx. " + LTRIM$(STR$(daypercent(2))) + "% usage."
	 PRINT #8, "   Tuesday " + LTRIM$(STR$(dy(3))); TAB(15); "- " + LTRIM$(STR$(ut(3) + st(3))) + " minutes used - approx. " + LTRIM$(STR$(daypercent(3))) + "% usage."
	 PRINT #8, " Wednesday " + LTRIM$(STR$(dy(4))); TAB(15); "- " + LTRIM$(STR$(ut(4) + st(4))) + " minutes used - approx. " + LTRIM$(STR$(daypercent(4))) + "% usage."
	 PRINT #8, "  Thursday " + LTRIM$(STR$(dy(5))); TAB(15); "- " + LTRIM$(STR$(ut(5) + st(5))) + " minutes used - approx. " + LTRIM$(STR$(daypercent(5))) + "% usage."
	 PRINT #8, "    Friday " + LTRIM$(STR$(dy(6))); TAB(15); "- " + LTRIM$(STR$(ut(6) + st(6))) + " minutes used - approx. " + LTRIM$(STR$(daypercent(6))) + "% usage."
	 PRINT #8, "  Saturday " + LTRIM$(STR$(dy(7))); TAB(15); "- " + LTRIM$(STR$(ut(7) + st(7))) + " minutes used - approx. " + LTRIM$(STR$(daypercent(7))) + "% usage."
	 PRINT #8, STRING$(79, 196)
	 PRINT #8, " BBS was active " + LTRIM$(STR$(INT(totaltime / 60))) + " hrs " + LTRIM$(STR$(((totaltime / 60) - INT(totaltime / 60)) * 60)) + " min -> average board load of " + LTRIM$(STR$(weekpercent)) + "%"
	 PRINT #8, ""
	 PRINT #8, "Regards,"
	 PRINT #8, "Tracker! " + ver$ + " by Cory Wright"
	 PRINT #8, "The Rising Connection 615-531-8789 GTNet 070/002"
	 CLOSE 8
	 'clear records
	 OPEN trakt$ FOR RANDOM AS 8 LEN = LEN(traktime)
	 FOR J = 1 TO 7
	 traktime.ucall = 0
	 traktime.scall = 0
	 traktime.utime = 0
	 traktime.stime = 0
	 traktime.day = 0
	 PUT 8, J, traktime
	 NEXT J
	 CLOSE 8
END SUB

SUB Ybulltotal (bull$) STATIC
ct = 0
filenum = FREEFILE
CALL exist(bull$ + CHR$(0), isthere%)
IF NOT isthere% THEN 5000
OPEN bull$ FOR INPUT AS filenum
FOR trash = 1 TO 6  ' header info
LINE INPUT #filenum, z$
NEXT trash
WHILE NOT EOF(filenum)    'find # calls
   ct = ct + 1
   LINE INPUT #filenum, z$
WEND
IF LEFT$(z$, 1) = CHR$(27) THEN ansicode = 1
CLOSE filenum

OPEN bull$ FOR APPEND AS filenum
IF ansicode <> 1 THEN
  PRINT #filenum, STRING$(79, 196)
  PRINT #filenum, "  - Total Calls: " + LTRIM$(STR$(ct))
 ELSE
  PRINT #filenum, hue$(border) + STRING$(79, 196)
  PRINT #filenum, hue$(info) + "  - Total Calls: " + CHR$(27) + "[37m" + LTRIM$(STR$(ct)) + CHR$(27) + "[0m"
END IF
CLOSE filenum

5000 END SUB

